  #include <stdio.h>
  #include <stdlib.h>
  #include <math.h>
  #include <dos.h>
  #include <malloc.h>
  #include <string.h>

  #include "g3def.h"
  #include "g3malloc.h"
  #include "g3lib.h"
  #include "g3land.h"
  #include "g3raw.h"
  #include "g3obj.h"

#define MARGIN G3_LANDGRIDSTEP*2
//#define MARGIN 0


lland_build(G3_OBJECT *ptrobject)
  {
  SD x1,z1;
  SD x2,z2;
  SD x3,z3;
  SD x4,z4;
  G3_POLYGON *ptrpolygon;
  G3_VERTEX *ptrvertex;
  G3_SKL *ptrskl;

  ptrpolygon=ptrobject->ptrpoly=(G3_POLYGON *)g3_malloc(sizeof(G3_POLYGON)*8+sizeof(ptrpolygon->type));
  ptrvertex=ptrobject->ptrvertex=(G3_VERTEX *)g3_malloc(sizeof(G3_VERTEX)*8+sizeof(ptrvertex->flag));
  ptrskl=ptrobject->ptrskl=(G3_SKL *)g3_malloc(sizeof(G3_SKL)+sizeof(ptrskl->recurse));

  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(0);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(4);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(0);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(1);
  ptrpolygon++;

  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(1);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(6);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(1);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(6);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(2);
  ptrpolygon++;

  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(2);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(6);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(2);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(3);
  ptrpolygon++;

  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(3);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(4);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x01010101;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(3);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(4);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(0);
  ptrpolygon++;

  ptrpolygon->type=G3_ENDMARK;

  /* build vertex for the horizon */

  x1=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z1=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  x2=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z2=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  x3=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z3=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  x4=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z4=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  // vertex 1
  ptrvertex->flag=0;
  ptrvertex->x=x1;
  ptrvertex->y=-MARGIN;
  ptrvertex->z=z1;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 2
  ptrvertex->flag=0;
  ptrvertex->x=x2;
  ptrvertex->y=-MARGIN;
  ptrvertex->z=z2;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 3
  ptrvertex->flag=0;
  ptrvertex->x=x3;
  ptrvertex->y=-MARGIN;
  ptrvertex->z=z3;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 4
  ptrvertex->flag=0;
  ptrvertex->x=x4;
  ptrvertex->y=-MARGIN;
  ptrvertex->z=z4;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;

  // vertex 1
  ptrvertex->flag=0;
  ptrvertex->x=x1;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z1;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 2
  ptrvertex->flag=0;
  ptrvertex->x=x2;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z2;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 3
  ptrvertex->flag=0;
  ptrvertex->x=x3;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z3;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 4
  ptrvertex->flag=0;
  ptrvertex->x=x4;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z4;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;


  ptrvertex->flag=G3_ENDMARK;

  /* build the minimum skel structure */

  ptrskl->recurse=1;
  ptrskl->translation.x=0;
  ptrskl->translation.y=0;
  ptrskl->translation.z=0;
  ptrskl->rotation.x=0;
  ptrskl->rotation.y=0;
  ptrskl->rotation.z=0;
  ptrskl->target.x=0;
  ptrskl->target.y=0;
  ptrskl->target.z=16;
  ptrskl++;
  ptrskl->recurse=G3_ENDMARK;
  }

hland_build(G3_OBJECT *ptrobject)
  {
  SD x1,z1;
  SD x2,z2;
  SD x3,z3;
  SD x4,z4;
  G3_POLYGON *ptrpolygon;
  G3_VERTEX *ptrvertex;
  G3_SKL *ptrskl;

  ptrpolygon=ptrobject->ptrpoly=(G3_POLYGON *)g3_malloc(sizeof(G3_POLYGON)*10+sizeof(ptrpolygon->type));
  ptrvertex=ptrobject->ptrvertex=(G3_VERTEX *)g3_malloc(sizeof(G3_VERTEX)*8+sizeof(ptrvertex->flag));
  ptrskl=ptrobject->ptrskl=(G3_SKL *)g3_malloc(sizeof(G3_SKL)+sizeof(ptrskl->recurse));

  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(0);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(4);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(0);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(1);
  ptrpolygon++;

  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(1);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(6);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(1);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(6);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(2);
  ptrpolygon++;

  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(2);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(6);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(2);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(3);
  ptrpolygon++;

  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(3);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(4);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(3);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(4);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(0);
  ptrpolygon++;


  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(6);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon++;
  ptrpolygon->type=0;
  ptrpolygon->color=0x02020202;
  ptrpolygon->pts1=(sizeof(G3_DVERTEX))*(7);
  ptrpolygon->pts2=(sizeof(G3_DVERTEX))*(5);
  ptrpolygon->pts3=(sizeof(G3_DVERTEX))*(4);
  ptrpolygon++;

  ptrpolygon->type=G3_ENDMARK;

  /* build vertex for the horizon */

  x1=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z1=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  x2=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z2=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  x3=((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z3=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  x4=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);
  z4=-((G3_GRIDSIZE/2)*G3_LANDGRIDSTEP);

  // vertex 1
  ptrvertex->flag=0;
  ptrvertex->x=x1;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z1;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 2
  ptrvertex->flag=0;
  ptrvertex->x=x2;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z2;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 3
  ptrvertex->flag=0;
  ptrvertex->x=x3;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z3;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 4
  ptrvertex->flag=0;
  ptrvertex->x=x4;
  ptrvertex->y=G3_LANDWAVEHEIGHT;
  ptrvertex->z=z4;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;

  // vertex 1
  ptrvertex->flag=0;
  ptrvertex->x=x1;
  ptrvertex->y=G3_LANDWAVEHEIGHT*2;
  ptrvertex->z=z1;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 2
  ptrvertex->flag=0;
  ptrvertex->x=x2;
  ptrvertex->y=G3_LANDWAVEHEIGHT*2;
  ptrvertex->z=z2;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 3
  ptrvertex->flag=0;
  ptrvertex->x=x3;
  ptrvertex->y=G3_LANDWAVEHEIGHT*2;
  ptrvertex->z=z3;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;
  // vertex 4
  ptrvertex->flag=0;
  ptrvertex->x=x4;
  ptrvertex->y=G3_LANDWAVEHEIGHT*2;
  ptrvertex->z=z4;
  ptrvertex->nx=0;
  ptrvertex->ny=0;
  ptrvertex->nz=0;
  ptrvertex++;


  ptrvertex->flag=G3_ENDMARK;

  /* build the minimum skel structure */

  ptrskl->recurse=1;
  ptrskl->translation.x=0;
  ptrskl->translation.y=0;
  ptrskl->translation.z=0;
  ptrskl->rotation.x=0;
  ptrskl->rotation.y=0;
  ptrskl->rotation.z=0;
  ptrskl->target.x=0;
  ptrskl->target.y=0;
  ptrskl->target.z=16;
  ptrskl++;
  ptrskl->recurse=G3_ENDMARK;
  }

main(int argc,char *argv[])
  {
  lland_build(g3_object_getaddr(0));
  g3_object_save(g3_object_getaddr(0),"LANDL");
  hland_build(g3_object_getaddr(1));
  g3_object_save(g3_object_getaddr(1),"LANDH");
  return(0);
  }





