

/**************************************************************************/
/*  G3LIB  : 3D GRAPHIC LIBRARY 											                    */
/**************************************************************************/

	#include <stdio.h>
	#include <stdlib.h>
	#include <math.h>
	#include <dos.h>
	#include <malloc.h>
	#include <string.h>
	#include <graph.h>
	#include <conio.h>

  #include "g3def.h"
  #include "g3malloc.h"
  #include "g3joy.h"
  #include "g3mouse.h"
  #include "g3iff.h"
  #include "g3lib.h"

/**************************************************************************/
/*            MAIN PROGRAM                                                */
/**************************************************************************/



  #define G3E_BLACK   0
  #define G3E_BLUE1   1
  #define G3E_BLUE2   2
  #define G3E_BLUE3   3
  #define G3E_RED     4
  #define G3E_GREEN   5
  #define G3E_BLUE    6
  #define G3E_WHITE   7



  #define MAXPANEL 3


  #define G3E_C_FIRSTFRAME    G3_KEY_HOME
  #define G3E_C_LASTFRAME     G3_KEY_END
  #define G3E_C_PLAY1         G3_KEY_F5
  #define G3E_C_PLAY2         G3_KEY_F6
  #define G3E_C_PLAY3         G3_KEY_F7
  #define G3E_C_PLAY4         G3_KEY_F8
  #define G3E_C_MODECOLOR     100001
  #define G3E_C_VIEWOBJECT      'f'
  #define G3E_C_VIEWGRID      'g'
  #define G3E_C_VIEWSKL      'k'



  G3_RSC framepanel[]=
  {
    /*--------------------------------------------------------------------------------------------*/
    /*                type,   x,  y,  w,  h,  t,ts,s,b,name                                       */
    /*--------------------------------------------------------------------------------------------*/
    {                   -3,   2,-28,  0,  0,  7, 5,0,0,""},
    {          G3_KEY_PGUP,  -1,  0, -1, -1,  7, 5,0,1,"{"},
    {                    0,  -1,  0, 50, -1,  7, 5,0,0," Frame"},
    {     G3E_C_FIRSTFRAME,  -1,  0, -1, -1,  7, 5,0,1,"|<"},
    {            G3_KEY_F1,  -1,  0, -1, -1,  7, 5,0,1,"<<"},
    {            G3_KEY_F2,  -1,  0, -1, -1,  7, 5,0,1,"<"},
    {            G3_KEY_F3,  -1,  0, -1, -1,  7, 5,0,1,">"},
    {            G3_KEY_F4,  -1,  0, -1, -1,  7, 5,0,1,">>"},
    {      G3E_C_LASTFRAME,  -1,  0, -1, -1,  7, 5,0,1,">|"},
    {          G3E_C_PLAY1,  -1,  0, -1, -1,  7, 5,0,1,"Play"},
    {          G3E_C_PLAY2,  -1,  0, -1, -1,  7, 5,0,1,"P2"},
    {          G3E_C_PLAY3,  -1,  0, -1, -1,  7, 5,0,1,"P3"},
    {          G3E_C_PLAY4,  -1,  0, -1, -1,  7, 5,0,1,"P4"},
    {                  'c',  -1,  0, -1, -1,  7, 5,0,1,"Copy"},
    {                  'p',  -1,  0, -1, -1,  7, 5,0,1,"Paste"},
    {           G3_KEY_DEL,  -1,  0, -1, -1,  7, 5,0,1,"Del"},
    {           G3_KEY_INS,  -1,  0, -1, -1,  7, 5,0,1,"Ins"},
    {                  'r',  -1,  0, -1, -1,  7, 5,0,1,"Reset"},
    {                   -3,   2,-18,  0,  0,  7, 5,0,0,""},
    {          G3_KEY_PGDN,  -1,  0, -1, -1,  7, 5,0,1,"}"},
    {                    0,  -1,  0, 50, -1,  7, 5,0,0," Chain"},
    {                  '&',  -1,  0, -1, -1,  7, 5,0,1,"RX"},
    {                  '',  -1,  0, -1, -1,  7, 5,0,1,"RY"},
    {                 '\"',  -1,  0, -1, -1,  7, 5,0,1,"RZ"},
    {                 '\'',  -1,  0, -1, -1,  7, 5,0,1,"TX"},
    {                  '(',  -1,  0, -1, -1,  7, 5,0,1,"TY"},
    {                  '-',  -1,  0, -1, -1,  7, 5,0,1,"TZ"},
    {                  '',  -1,  0, -1, -1,  7, 5,0,1,"Reset"},
    {                   -1,   0,  0,  0,  0,  7, 5,0,0,""}
  };

  G3_RSC anipanel[]=
  {
    /*--------------------------------------------------------------------------------------------*/
    /*                type,   x,  y,  w,  h,  t,ts,s,b,name                                       */
    /*--------------------------------------------------------------------------------------------*/
    {                   -3,   2,-28,  0,  0,  7, 5,0,0,""},
    {          G3_KEY_PGUP,  -1,  0, -1, -1,  7, 5,0,1,"{"},
    {                    0,  -1,  0, 50, -1,  7, 5,0,0,"Anim"},
    {                  'l',  -1,  0, -1, -1,  7, 5,0,1,"Load"},
    {                  's',  -1,  0, -1, -1,  7, 5,0,1,"Save"},
    {                  'S',  -1,  0, -1, -1,  7, 5,0,1,"Save as..."},
    {                   -3,   2,-18,  0,  0,  7, 5,0,0,""},
    {          G3_KEY_PGDN,  -1,  0, -1, -1,  7, 5,0,1,"}"},
    {                   -1,   0,  0,  0,  0,  7, 5,0,0,""}
  };


  G3_RSC campanel[]=
  {
    /*--------------------------------------------------------------------------------------------*/
    /*                type,   x,  y,  w,  h,  t,ts,s,b,name                                       */
    /*--------------------------------------------------------------------------------------------*/
    {                   -3,   2,-28,  0,  0,  7, 5,0,0,""},
    {          G3_KEY_PGUP,  -1,  0, -1, -1,  7, 5,0,1,"{"},
    {                    0,  -1,  0, 50, -1,  7, 5,0,0,"Camera"},
    {                    0,  -1,  0, -1, -1,  7, 5,0,1,"UP"},
    {                    0,  -1,  0, -1, -1,  7, 5,0,1,"DOWN"},
    {                    0,  -1,  0, -1, -1,  7, 5,0,1,"LEFT"},
    {                    0,  -1,  0, -1, -1,  7, 5,0,1,"RIGHT"},
    {                   -3,   2,-18,  0,  0,  7, 5,0,0,""},
    {          G3_KEY_PGDN,  -1,  0, -1, -1,  7, 5,0,1,"}"},
    {                    0,  -1,  0, 50, -1,  7, 5,0,0,"View"},
    {            G3_KEY_F9,  -1,  0, -1, -1,  7, 5,0,1,"Prev frm"},
    {           G3_KEY_F10,  -1,  0, -1, -1,  7, 5,0,1,"Next frm"},
    {       G3E_C_VIEWSKL,  -1,  0, -1, -1,  7, 5,0,1,"Skel"},
    {       G3E_C_VIEWOBJECT,  -1,  0, -1, -1,  7, 5,0,1,"Form"},
    {       G3E_C_VIEWGRID,  -1,  0, -1, -1,  7, 5,0,1,"Grid"},
    {                  '/',  -1,  0, -1, -1,  7, 5,0,1,"CPU"},
    {                   -1,   0,  0,  0,  0,  7, 5,0,0,""}
  };



  G3_RSC *panel[MAXPANEL]=
  {
  framepanel,
  anipanel,
  campanel
  };


#define MAXANIFRAME  (2048)

SD g3_edit_cptundo;
SD g3_edit_nundo;
SD g3_edit_prevframeshadow;
SD g3_edit_nextframeshadow;
SD g3_edit_wire;
SD g3_edit_viewgrid;
SD g3_edit_viewskl;
SD g3_edit_viewobject;
SD g3_edit_cpu;
SD  g3_edit_viewmode=0;
SD g3_edit_zoom;
SD g3_edit_sklaxis;
G3_SKL *g3_edit_ptrskl;

G3_ANIFRAME *g3e_aniframe_new(G3_OBJECT *ptrobject)
  {
  G3_SKL *ptrskl;
  G3_ANIFRAME *aniframe;
  ptrskl=ptrobject->ptrskl;
  aniframe=(G3_ANIFRAME *)g3_malloc(sizeof(G3_ANIFRAME));
  if(aniframe!=NULL)
    {
    aniframe->sklpos=g3_sklpos_new(ptrobject);
    if(aniframe->sklpos==NULL)
      {
      g3_free(&aniframe);
      aniframe=NULL;
      }
    }
  else
    {
    printf("Allocation in g3e_aniframe_new\n");
    }
  return(aniframe);
  }


void display_aniframe_bar(G3_ANIFRAME **aniframe,SD naniframe,SD cptaniframe)
  {
  SD *ptrcolumn,*ptrline;
  SD linesize;
  SD color1,color2;
  SD i;
  SD maxcase;
  SD limit;
  ptrcolumn=(SD *)g3_window_getaddr();
  linesize=g3_screenw/(sizeof(SD));
  ptrcolumn+=(g3_screenh-7)*linesize;
  maxcase=g3_screenw/(sizeof(SD)*2);
  i=naniframe-(maxcase>>1);
  limit=i+maxcase;
  while(i<limit)
    {
    if(i<0 || i>=cptaniframe)
      {
      color1=0x00000000;
      }
    else
      {
      if(aniframe[i]==NULL)
        color1=0x04040404;
      else
        color1=0x05050505;
      }
    color2=color1 & 0x00FFFFFF;

    ptrline=ptrcolumn;

    if(i==naniframe)
      {
      *ptrline=0x06060606;
      *(ptrline+1)=0x00060606;
      ptrline+=linesize;
      }
    else
      {
      *ptrline=color1;
      *(ptrline+1)=color2;
      ptrline+=linesize;
      }

    *ptrline=color1;
    *(ptrline+1)=color2;
    ptrline+=linesize;

    *ptrline=color1;
    *(ptrline+1)=color2;
    ptrline+=linesize;

    *ptrline=color1;
    *(ptrline+1)=color2;
    ptrline+=linesize;

    *ptrline=color1;
    *(ptrline+1)=color2;
    ptrline+=linesize;

    *ptrline=color1;
    *(ptrline+1)=color2;

    ptrcolumn+=2;

    i++;
    }
  }


SD nextrealframe(G3_ANIFRAME **aniframe,SD naniframe,SD cptaniframe)
  {
  SD n;
  n=naniframe;
  while(n<cptaniframe && aniframe[n]==NULL)
    {
    n++;
    }
  return(n);
  }


SD prevrealframe(G3_ANIFRAME **aniframe,SD naniframe)
  {
  SD n;
  n=naniframe;
  while(n>=0 && aniframe[n]==NULL)
    {
    n--;
    }
  return(n);
  }

void g3e_aniblock_save(G3_FILE *handle,G3_SKL *ptrskl,G3_ANIFRAME **aniframe,SD cptaniframe)
  {
  SD version;
  SD cpt;
  SD i;
  version=1;
  g3_fwrite(&version,1,sizeof(SD),handle);
  cpt=0;
  for(i=0;i<cptaniframe;i++)
    {
    if(aniframe[i]!=NULL)
      {
      cpt++;
      switch(version)
        {
        case 1:
          g3_fwrite(&cpt,1,sizeof(SD),handle);
          g3_fwrite(&aniframe[i]->blockedskl,1,sizeof(SD),handle);
          g3_fwrite(aniframe[i]->sklpos,1,sizeof(G3_SKLPOS)*g3_skl_count(ptrskl),handle);
          break;
        default:
          break;
        }
      cpt=0;
      }
    else
      {
      cpt++;
      }
    }
  version=-1;
  g3_fwrite(&version,1,sizeof(SD),handle);
  }


SD g3e_ani_save(char *filename,G3_SKL *ptrskl,G3_ANIFRAME **aniframe,SD cptaniframe)
  {
  G3_FILE *handle;
  handle=g3_fopen(filename,"wb");
  if(handle!=NULL)
    {
    g3e_aniblock_save(handle,ptrskl,aniframe,cptaniframe);
    fclose(handle);
    return(G3_TRUE);
    }
  else
    {
    return(G3_FALSE);
    }
  }


void g3e_aniblock_load(G3_FILE *handle,G3_SKL *ptrskl,G3_ANIFRAME **aniframe,SD *cptaniframe)
  {
  SD version;
  SD i;
  SD nbframe;
  SD size;
  g3_fread(&version,1,sizeof(SD),handle);
  switch(version)
    {
    case 1:
      size=sizeof(G3_SKLPOS)*g3_skl_count(ptrskl);
      *cptaniframe=0;
      g3_fread(&nbframe,1,sizeof(SD),handle);
      while(nbframe!=-1)
        {
        for(i=*cptaniframe;i<*cptaniframe+nbframe;i++)
          {
          aniframe[i]=NULL;
          }
        *cptaniframe+=nbframe-1;
        aniframe[*cptaniframe]=(G3_ANIFRAME *)g3_malloc(sizeof(G3_ANIFRAME));
        aniframe[*cptaniframe]->sklpos=(G3_SKLPOS *)g3_malloc(size);
        aniframe[*cptaniframe]->nbframe=nbframe;
        g3_fread(&aniframe[*cptaniframe]->blockedskl,1,sizeof(SD),handle);
        g3_fread(aniframe[*cptaniframe]->sklpos,1,size,handle);
        g3_fread(&nbframe,1,sizeof(SD),handle);
        *cptaniframe = *cptaniframe + 1;
        }
      break;
    default:
      break;
    }
  }


SD g3e_ani_load(char *filename,G3_SKL *ptrskl,G3_ANIFRAME **aniframe,SD *cptaniframe)
  {
  G3_FILE *handle;
  handle=g3_fopen(filename,"rb");
  if(handle!=NULL)
    {
    g3e_aniblock_load(handle,ptrskl,aniframe,cptaniframe);
    fclose(handle);
    return(G3_TRUE);
    }
  else
    {
    return(G3_FALSE);
    }
  }


#define G3E_MAXUNDO 512

void g3e_undo_store(G3_SKL *ptrskl,G3_ANIFRAME **aniframe,SD naniframe,SD cptaniframe)
  {
  G3_FILE *handle;
  char string[256];
  g3_edit_nundo++;
  if(g3_edit_cptundo<G3E_MAXUNDO)
    {
    g3_edit_cptundo++;
    }
  if(g3_edit_nundo>=G3E_MAXUNDO)
    {
    g3_edit_nundo=0;
    }
  sprintf(string,"%s\\UNDO\\ANI.%d",g3_path_get(),g3_edit_nundo);
  handle=g3_fopen(string,"wb");
  if(handle!=NULL)
    {
    g3_fwrite(&naniframe,1,sizeof(SD),handle);
    g3e_aniblock_save(handle,ptrskl,aniframe,cptaniframe);
    fclose(handle);
    }
  }

void g3e_undo(G3_SKL *ptrskl,G3_ANIFRAME **aniframe,SD *naniframe,SD *cptaniframe)
  {
  G3_FILE *handle;
  char string[256];
  sprintf(string,"%s\\UNDO\\ANI.%d",g3_path_get(),g3_edit_nundo);
  handle=g3_fopen(string,"rb");
  if(handle!=NULL)
    {
    g3_fread(naniframe,1,sizeof(SD),handle);
    g3e_aniblock_load(handle,ptrskl,aniframe,cptaniframe);
    fclose(handle);
    }
  g3_edit_nundo--;
  if(g3_edit_nundo<0)
    {
    g3_edit_nundo=0;
    }
  }

void g3e_redo(G3_SKL *ptrskl,G3_ANIFRAME **aniframe,SD *naniframe,SD *cptaniframe)
  {
  G3_FILE *handle;
  char string[256];
  g3_edit_nundo++;
  if(g3_edit_nundo>=g3_edit_cptundo)
    {
    g3_edit_nundo=g3_edit_cptundo-1;
    }
  sprintf(string,"%s\\UNDO\\ANI.%d",g3_path_get,g3_edit_nundo);
  handle=g3_fopen(string,"rb");
  if(handle!=NULL)
    {
    g3_fread(naniframe,1,sizeof(SD),handle);
    g3e_aniblock_load(handle,ptrskl,aniframe,cptaniframe);
    fclose(handle);
    }
  }


void g3e_ani_free(G3_ANIFRAME **aniframe,SD cptaniframe)
  {
  SD i;
  for(i=0;i<cptaniframe;i++)
    {
    if(aniframe[i]!=NULL)
      {
      g3_free(&aniframe[i]->sklpos);
      g3_free(&aniframe[i]);
      }
    }
  }

void g3e_display_grid(SD x1,SD y1,SD z1,SD x2,SD y2,SD z2,SD stepx,SD stepy,SD stepz,G3_MATRIX *matrix)
  {
  }

void g3e_displayframe(G3_ANIFRAME **aniframe,SD naniframe,SD cptaniframe,G3_OBJECT *g3_object,G3_MATRIX *matrix)
  {
  SD n1,n2;
  if(aniframe[naniframe]==NULL)
    {
    n1=prevrealframe(aniframe,naniframe);
    n2=nextrealframe(aniframe,naniframe,cptaniframe);
    if(n1<0) n1=0;
    if(aniframe[n1]==NULL) n1=n2;
    g3_sklpos_put(aniframe[n1]->sklpos,g3_object->ptrskl);
    g3_object->framecount=n2-n1;
    if(g3_object->framecount==0) g3_object->framecount=1;
    g3_object->sklpos=aniframe[n2]->sklpos;
    n1=naniframe-n1;
    g3_object_motionprepare(g3_object);
    for(n2=0;n2<n1;n2++)
      g3_object_motionprogress(g3_object);
    }
  else
    {
    g3_sklpos_put(aniframe[naniframe]->sklpos,g3_object->ptrskl);
    }
  g3_object_prepare(g3_object);
  g3_object_compute(g3_object);
  }

void g3e_displayprevframe(G3_ANIFRAME **aniframe,SD naniframe,SD cptaniframe,G3_OBJECT *g3_object,G3_MATRIX *matrix)
  {
  SD n1;
  if(g3_edit_prevframeshadow)
    {
    n1=naniframe-1;
    if(n1<0) n1=cptaniframe-1;
    n1=prevrealframe(aniframe,n1);
    if(n1<0) n1=0;
    g3_edit_wire=G3_TRUE;
    g3e_displayframe(aniframe,n1,cptaniframe,&g3_object[0],matrix);
    g3_edit_wire=G3_FALSE;
    }
  }

void g3e_displaynextframe(G3_ANIFRAME **aniframe,SD naniframe,SD cptaniframe,G3_OBJECT *g3_object,G3_MATRIX *matrix)
  {
  SD n1;
  if(g3_edit_nextframeshadow)
    {
    n1=naniframe+1;
    if(n1<0) n1=cptaniframe-1;
    n1=nextrealframe(aniframe,n1,cptaniframe);
    if(n1>=cptaniframe) n1=0;
    n1=nextrealframe(aniframe,n1,cptaniframe);
    g3_edit_wire=G3_TRUE;
    g3e_displayframe(aniframe,n1,cptaniframe,&g3_object[0],matrix);
    g3_edit_wire=G3_FALSE;
    }
  }

void g3e_displayallframe(G3_ANIFRAME **aniframe,SD naniframe,SD cptaniframe,G3_OBJECT *g3_object,G3_MATRIX *matrix)
  {
  if(g3_edit_viewgrid)
    {
    g3e_display_grid(-256*g3_edit_viewgrid,0,-256*g3_edit_viewgrid,256*g3_edit_viewgrid,0,256*g3_edit_viewgrid,32,32,32,matrix);
    }
/*
  g3_ot_clear();
  g3e_displaynextframe(aniframe,naniframe,cptaniframe,&g3_object[0],matrix);
  G3_OT_DISPLAYwire();

  g3_ot_clear();
  g3e_displayprevframe(aniframe,naniframe,cptaniframe,&g3_object[0],matrix);
  G3_OT_DISPLAYwire();
*/
  g3_ot_clear();
  g3e_displayframe(aniframe,naniframe,cptaniframe,&g3_object[0],matrix);
  G3_OT_DISPLAY();
  }

SD g3e_getsklvalue(G3_SKL *ptrskl,SD sklaxis)
  {
  SD value;
  if(ptrskl!=NULL)
    {
    switch(sklaxis)
      {
      case 0:
        value=G3_ANGLE(ptrskl->rotation.x);
        break;
      case 1:
        value=G3_ANGLE(ptrskl->rotation.y);
        break;
      case 2:
        value=G3_ANGLE(ptrskl->rotation.z);
        break;
      case 3:
        value=ptrskl->translation.x;
        break;
      case 4:
        value=ptrskl->translation.y;
        break;
      case 5:
        value=ptrskl->translation.z;
        break;
      }
    }
  else
    {
    value=0;
    }
  return(value);
  }

void g3e_setsklvalue(G3_SKL *ptrskl,SD sklaxis,SD value)
  {
  if(ptrskl!=NULL)
    {
    switch(sklaxis)
      {
      case 0:
        ptrskl->rotation.x=G3_ANGLE(value);
        break;
      case 1:
        ptrskl->rotation.y=G3_ANGLE(value);
        break;
      case 2:
        ptrskl->rotation.z=G3_ANGLE(value);
        break;
      case 3:
        ptrskl->translation.x=value;
        break;
      case 4:
        ptrskl->translation.y=value;
        break;
      case 5:
        ptrskl->translation.z=value;
        break;
      }
    }
  }


main(SD argc,char *argv[] )
	{
  G3_MATRIX mrt;
  G3_VECTOR      camtranslation;
  G3_ROTATION    camrotation;
  G3_ANIFRAME **aniframe;
  G3_SKLPOS *tmpsklpos;
  G3_SKLPOS *nullsklpos;
  SD waitmouse;
  SD naniframe;
  SD cptaniframe;
  SD i;
  SD omx,omy;
  SD currentpanel;
  G3_RSC *ptrrsc=NULL;
  G3_RSC *tmprsc;
  struct find_t  fileinfo;
  unsigned rc;
  SD lastkey;
  char string[256];
  char drive[ _MAX_DRIVE ];
  char dir[ _MAX_DIR ];
  char fname[ _MAX_FNAME ];
  char ext[ _MAX_EXT ];
  char filename[ _MAX_FNAME ];

	g3_path_set(argv[0]);
/*
  _splitpath(argv[0],drive,dir,fname,ext);
  _makepath(g3_edit_path,drive,dir,"","");

  printf("%sDSANI.EXE %s %s %s",g3_edit_path,__DATE__,__TIME__);
*/

  currentpanel=0;

  g3_edit_nextframeshadow=G3_FALSE;
  g3_edit_prevframeshadow=G3_FALSE;
  g3_edit_viewskl=G3_FALSE;
  g3_edit_viewobject=G3_TRUE;
  g3_edit_viewgrid=0;
  g3_edit_cpu=G3_FALSE;
  g3_edit_cptundo=0;
  g3_edit_nundo=-1;


  sprintf(string,"%sFONT\\FONTLOW.DAT",g3_path_get());
  g3_fontlow=g3_font_load(string);
  if(g3_fontlow==NULL)
    {
    printf("Can t find %s\n",string);
    return(-1);
    }

  sprintf(string,"%sFONT\\FONTHIGH.DAT",g3_path_get());
  g3_fonthigh=g3_font_load(string);
  if(g3_fonthigh==NULL)
    {
    printf("Can't find %s\n",string);
    return(-1);
    }

  rc=_dos_findfirst( "*.ENV", _A_NORMAL, &fileinfo );
  if(rc!=0)
    {
    return(-1);
    }
  _splitpath(fileinfo.name,drive,dir,fname,ext);
  _makepath(filename,drive,dir,fname,"");


  g3_object_vtxload(filename,&g3_object[0]);
  g3_object_envload(filename,&g3_object[0]);
  g3_object_sklload(filename,&g3_object[0]);

  /*


  g3_edit_ptrskl=NULL;
  g3_edit_sklaxis=0;

    g3_timer_init();
	*/

  naniframe=0;
  aniframe=(G3_ANIFRAME **)g3_malloc(sizeof(G3_ANIFRAME *)*MAXANIFRAME);

  for(i=0;i<MAXANIFRAME;i++) aniframe[i]=NULL;

  if(!g3e_ani_load(argv[1],g3_object[0].ptrskl,aniframe,&cptaniframe))
    {
    aniframe[0]=g3e_aniframe_new(&g3_object[0]);
    cptaniframe=1;
    }


  tmpsklpos=g3_sklpos_new(&g3_object[0]);
  nullsklpos=g3_sklpos_new(&g3_object[0]);


  g3_init(0x13);
  sprintf(string,"%s\\BANK\\BANK",g3_path_get());
  g3_bank_load(string);
  g3_setallcolorregister();

  if(!g3_mouse_init(g3_screenw,g3_screenh))
    {
    printf("Mouse driver not found. Aborting program\n");
    }

  g3_edit_viewmode=0;
	g3_edit_zoom=1<<G3_FPSHIFT;
  g3_object[0].rotation.x=G3_FPANGLE(0);
  g3_object[0].rotation.y=G3_FPANGLE(0);
  g3_object[0].rotation.z=G3_FPANGLE(0);
  g3_object[0].translation.x=G3_FPVALUE(0);
  g3_object[0].translation.y=G3_FPVALUE(0);
  g3_object[0].translation.z=G3_FPVALUE(0);
  camrotation.x=G3_FPANGLE(0);
  camrotation.y=G3_FPANGLE(0);
  camrotation.z=G3_FPANGLE(0);
  camtranslation.x=G3_FPVALUE(0);
  camtranslation.y=G3_FPVALUE(0);
  camtranslation.z=G3_FPVALUE(512);
  waitmouse=0;
  g3_setpolarcamera(&camrotation,&camtranslation);

  do
    {
    lastkey=g3_mouse_getkey();
    omx=-1;
    omy=-1;
    /*---------------------- wait until event -----------------------*/
    g3_mouse_waitevent();
        /*---------------- display object --------------------------*/
        G3_MATRIX_ROTZROTXROTYTRANSLATE(&g3_object[0].rotation,&g3_object[0].translation,&mrt);
        g3e_displayallframe(aniframe,naniframe,cptaniframe,&g3_object[0],&mrt);
       /*---------------------- unselect chain items -------------------*/
        tmprsc=g3_rsc_find(framepanel,'&');
        tmprsc->select=0;
        tmprsc=g3_rsc_find(framepanel,'');
        tmprsc->select=0;
        tmprsc=g3_rsc_find(framepanel,'\"');
        tmprsc->select=0;
        tmprsc=g3_rsc_find(framepanel,'\'');
        tmprsc->select=0;
        tmprsc=g3_rsc_find(framepanel,'(');
        tmprsc->select=0;
        tmprsc=g3_rsc_find(framepanel,'-');
        tmprsc->select=0;
        tmprsc=g3_rsc_find(campanel,10004);
        tmprsc->select=g3_edit_prevframeshadow;
        tmprsc=g3_rsc_find(campanel,10005);
        tmprsc->select=g3_edit_nextframeshadow;
        /*--------------------- select current chain item --------------*/
        switch(g3_edit_sklaxis)
          {
          case 0:
            tmprsc=g3_rsc_find(framepanel,'&');
            break;
          case 1:
            tmprsc=g3_rsc_find(framepanel,'');
            break;
          case 2:
            tmprsc=g3_rsc_find(framepanel,'\"');
            break;
          case 3:
            tmprsc=g3_rsc_find(framepanel,'\'');
            break;
          case 4:
            tmprsc=g3_rsc_find(framepanel,'(');
            break;
          case 5:
            tmprsc=g3_rsc_find(framepanel,'-');
            break;
          }
        tmprsc->select=1;
        /*---------------- display panel ------------------------*/
        g3_rsc_display(panel[currentpanel],0,0);
        /*---------------- display frame bar --------------------*/
        display_aniframe_bar(aniframe,naniframe,cptaniframe);
        /*---------------- display info -------------------------*/
        sprintf(string,"%s  %d/%d",argv[1],naniframe,cptaniframe);
        g3_string_put(g3_font,0,0,string,7);
        /*---------------- display mouse ------------------------*/
        /*---------------- screen refresh ----------------------*/
        g3_screen_swap();
        G3_SCREEN_CLEAR(0);
        omx=g3_mouse_getx();
        omy=g3_mouse_gety();

      if(ptrrsc!=NULL) ptrrsc->select=0;

    /*-------------------- we must wait for mouse realease ------------------*/
    if(waitmouse)
      {
      while(g3_mouse_getbutton()!=0) g3_mouse_get();
      waitmouse=0;
      }
    /*-------------------- if rsc or key event -------------------------------*/
    if(g3_mouse_getbutton()==1)
      {
      /*------------------ is the mouse on keyframe box ? --------------*/
      if(g3_mouse_gety()>=g3_screenh-6)
        {
        if(g3_mouse_getx()==0 || g3_mouse_getx()>=g3_screenw-1)
          {
          if(g3_mouse_getx()==0)
            {
//            g3_mouse_setkey(G3_KEY_F2);
            }
          else
            {
//            g3_mouse_setkey(G3_KEY_F3);
            }
          }
        else
          {
          naniframe+=(g3_mouse_getx()/8)-(g3_screenw/8)/2;
          if(naniframe<0)
            naniframe=0;
          else
            if(naniframe>=cptaniframe) naniframe=cptaniframe-1;
          waitmouse=1;
          }
        }
      else
        {
        ptrrsc=g3_rsc_select(panel[currentpanel],0,0,g3_mouse_getx(),g3_mouse_gety());
        ptrrsc->select=1;
//        g3_mouse_setkey(ptrrsc->type);
        if(g3_mouse_getkey()==-1)
					{
          g3_edit_ptrskl=g3_skl_select(g3_object[0].ptrskl,g3_mouse_getx(),g3_mouse_gety());
					}
        }
      }

    else if(g3_mouse_getbutton()==2)
      {
      if(g3_edit_ptrskl!=NULL && g3_edit_sklaxis<=2)
        {
        SD omx,omy;
        SD ovalue;
        omx=g3_mouse_getx();
        omy=g3_mouse_gety();
        g3e_undo_store(g3_object[0].ptrskl,aniframe,naniframe,cptaniframe);
        if(aniframe[naniframe]==NULL)
          {
          aniframe[naniframe]=g3e_aniframe_new(&g3_object[0]);
          }
        ovalue=g3e_getsklvalue(g3_edit_ptrskl,g3_edit_sklaxis);
        g3_mouse_reinit((G3_NBANGLE/2)/32,(G3_NBANGLE/2)/32,G3_NBANGLE/32,G3_NBANGLE/32);
        do
          {
          G3_MATRIX_ROTZROTXROTYTRANSLATE(&g3_object[0].rotation,&g3_object[0].translation,&mrt);
          g3_mouse_get();
          g3e_setsklvalue(g3_edit_ptrskl,g3_edit_sklaxis,ovalue-G3_FPANGLE(G3_NBANGLE/2)+G3_FPANGLE(g3_mouse_gety()*32));
          g3_sklpos_get(g3_object[0].ptrskl,aniframe[naniframe]->sklpos);
          g3e_displayallframe(aniframe,naniframe,cptaniframe,&g3_object[0],&mrt);
          /*---------------- screen refresh ----------------------*/
          g3_screen_swap();
          G3_SCREEN_CLEAR(0);
          }
        while(g3_mouse_getbutton()==2);
        if(g3_mouse_getbutton()==3)
          {
          g3e_setsklvalue(g3_edit_ptrskl,g3_edit_sklaxis,ovalue);
          g3_sklpos_get(g3_object[0].ptrskl,aniframe[naniframe]->sklpos);
          while(g3_mouse_getbutton()==3) g3_mouse_get();
          }
        g3_mouse_reinit(omx,omy,g3_screenw,g3_screenh);
        waitmouse=1;
        }
      }

      #if 0
        else
          {
          if(g3_mouse_getbutton()==1)
            {
            SD omx,omy;
            SD ovaluex,ovaluey;
            omx=g3_mouse_getx();
            omy=g3_mouse_gety();
            ovaluex=camrotation.x;
            ovaluey=camrotation.y;
            g3_mouse_reinit((G3_NBANGLE/2)/32,(G3_NBANGLE/2)/32,G3_NBANGLE/32,G3_NBANGLE/32);
            do
              {
              camrotation.y=ovaluey-G3_FPANGLE(G3_NBANGLE/2)+G3_FPANGLE(g3_mouse_getx()*32);
              camrotation.x=ovaluex-G3_FPANGLE(G3_NBANGLE/2)+G3_FPANGLE(g3_mouse_gety()*32);
              g3_setpolarcamera(&camrotation,&camtranslation);
              G3_MATRIX_ROTZROTXROTYTRANSLATE(&g3_object[0].rotation,&g3_object[0].translation,&mrt);
              g3_mouse_get();
              g3e_displayallframe(aniframe,naniframe,cptaniframe,&g3_object[0],&mrt);
              g3_screen_swap();
              G3_SCREEN_CLEAR(0);
              }
            while(g3_mouse_getbutton()==1);
            g3_mouse_reinit(omx,omy,g3_screenw,g3_screenh);
            }
          }
        }
      #endif

    switch(g3_mouse_getkey())
        {
        case 0:
            break;
        case '/':
            g3_edit_cpu= !g3_edit_cpu;
            waitmouse=1;
            break;
        case G3_KEY_BACKSPACE:
            g3e_undo(g3_object[0].ptrskl,aniframe,&naniframe,&cptaniframe);
            break;
        case G3_KEY_TAB:
            g3e_redo(g3_object[0].ptrskl,aniframe,&naniframe,&cptaniframe);
            break;
        case G3_KEY_F9:
            g3_edit_prevframeshadow = !g3_edit_prevframeshadow;
            waitmouse=1;
            break;
        case G3_KEY_F10:
            g3_edit_nextframeshadow = !g3_edit_nextframeshadow;
            waitmouse=1;
            break;
        case G3_KEY_PGUP:
            currentpanel--;
            if(currentpanel<0) currentpanel=MAXPANEL-1;
            waitmouse=1;
            break;
        case G3_KEY_PGDN:
            currentpanel++;
            if(currentpanel>=MAXPANEL) currentpanel=0;
            waitmouse=1;
            break;
        /*--------------- insert a frame at the place -------------------------*/
        case G3_KEY_INS:
          g3e_undo_store(g3_object[0].ptrskl,aniframe,naniframe,cptaniframe);
          {
          SD i;
          for(i=cptaniframe;i>naniframe;i--)
            {
            aniframe[i]=aniframe[i-1];
            }
          aniframe[naniframe]=NULL;
          cptaniframe++;
          }
          waitmouse=1;
          break;
        /*--------------- delete a frame -------------------------*/
        case G3_KEY_DEL:
          g3e_undo_store(g3_object[0].ptrskl,aniframe,naniframe,cptaniframe);
          if(naniframe<cptaniframe-1)
            {
            if(aniframe[naniframe]!=NULL)
              {
              g3_free(&aniframe[naniframe]->sklpos);
              g3_free(&aniframe[naniframe]);
              aniframe[i]=NULL;
              }
            {
            SD i;
            for(i=naniframe;i<cptaniframe-1;i++)
                {
                aniframe[i]=aniframe[i+1];
                }
            cptaniframe--;
            if(naniframe>=cptaniframe)
              {
              naniframe=cptaniframe-1;
              }
            }
            waitmouse=1;
            }
          else
            {
            if(naniframe-1>=0)
              {
              if(aniframe[naniframe-1]!=NULL)
                {
                g3_free(&aniframe[naniframe]->sklpos);
                g3_free(&aniframe[naniframe]);
                naniframe--;
                cptaniframe--;
                }
              }
            }
          break;
        /*--------------- goto first frame -------------------------*/
        case G3E_C_FIRSTFRAME:
          naniframe=0;
          waitmouse=1;
          break;
        /*--------------- goto last frame -------------------------*/
        case G3E_C_LASTFRAME:
          naniframe=cptaniframe-1;
          waitmouse=1;
          break;
        /*--------------- goto previous real frame -------------------------*/
        case G3_KEY_F1:
          if(naniframe>0)
            {
            naniframe--;
            naniframe=prevrealframe(aniframe,naniframe);
            if(naniframe<0) naniframe=0;
            }
          waitmouse=1;
          break;
        /*--------------- goto previous frame -------------------------*/
        case G3_KEY_F2:
          if(naniframe>0)
            {
            naniframe--;
            }
          waitmouse=1;
          break;
        /*--------------- goto next frame -------------------------*/
        case G3_KEY_F3:
          if(naniframe<MAXANIFRAME-1)
            {
            naniframe++;
            if(naniframe>=cptaniframe)
              {
              cptaniframe++;
              aniframe[naniframe]=g3e_aniframe_new(&g3_object[0]);
              }
            }
          waitmouse=1;
          break;
        /*--------------- goto next real frame -------------------------*/
        case G3_KEY_F4:
          if(naniframe<cptaniframe-1)
            {
            naniframe++;
            naniframe=nextrealframe(aniframe,naniframe,cptaniframe);
            if(naniframe>=cptaniframe) naniframe=cptaniframe-1;
            }
          waitmouse=1;
          break;
        /*--------------- play anim -------------------------*/
        case G3E_C_PLAY1:
          naniframe+=1;
          if(naniframe>=cptaniframe)
            naniframe=0;
          break;
        /*--------------- play anim x 2-------------------------*/
        case G3E_C_PLAY2:
          naniframe+=2;
          if(naniframe>=cptaniframe)
            naniframe=0;
          break;
        /*--------------- play anim x 3-------------------------*/
        case G3E_C_PLAY3:
          naniframe+=3;
          if(naniframe>=cptaniframe)
          naniframe=0;
          break;
        /*--------------- play anim x 4-------------------------*/
        case G3E_C_PLAY4:
          naniframe+=4;
          if(naniframe>=cptaniframe)
          naniframe=0;
          break;
        /*--------------- view skletron -------------------------*/
        case G3E_C_VIEWSKL:
          g3_edit_viewskl=!g3_edit_viewskl;
          waitmouse=1;
          break;
        /*--------------- view object -------------------------*/
        case G3E_C_VIEWOBJECT:
          g3_edit_viewobject=!g3_edit_viewobject;
          waitmouse=1;
          break;
        /*--------------- view grid -------------------------*/
        case G3E_C_VIEWGRID:
          g3_edit_viewgrid=(g3_edit_viewgrid+1) & 0x03;
          waitmouse=1;
          break;
        /*--------------- change resolution -------------------------*/
        case '*':
          switch(g3_videomode)
            {
            case 0x13:
              g3_init(0x101);
              break;
            case 0x101:
              g3_init(0x13);
              break;
            }
          g3_setallcolorregister();
          g3_mouse_init(g3_screenw,g3_screenh);
          break;
        /*--------------- store current skl pos -------------*/
        case 'c':
          g3e_undo_store(g3_object[0].ptrskl,aniframe,naniframe,cptaniframe);
          g3_sklpos_get(g3_object[0].ptrskl,tmpsklpos);
          waitmouse=1;
          break;
        /*--------------- paste current skl pos -------------*/
        case 'p':
          g3e_undo_store(g3_object[0].ptrskl,aniframe,naniframe,cptaniframe);
          if(aniframe[naniframe]==NULL)
            {
            aniframe[naniframe]=g3e_aniframe_new(&g3_object[0]);
            }
          g3_sklpos_put(tmpsklpos,g3_object[0].ptrskl);
          waitmouse=1;
          break;
        /*--------------- ROT X -------------------------*/
        case '&':
          g3_edit_sklaxis=0;
          break;
        /*--------------- ROT Y -------------------------*/
        case '':
          g3_edit_sklaxis=1;
          break;
        /*--------------- ROT Z -------------------------*/
        case '"':
          g3_edit_sklaxis=2;
          break;
        /*--------------- T X -------------------------*/
        case '\'':
          g3_edit_sklaxis=3;
          break;
        /*--------------- T Y -------------------------*/
        case '(':
          g3_edit_sklaxis=4;
          break;
        /*--------------- T Z -------------------------*/
        case '-':
          g3_edit_sklaxis=5;
          break;
        /*--------------- Reset -------------------------*/
        case '':
          g3e_undo_store(g3_object[0].ptrskl,aniframe,naniframe,cptaniframe);
          g3_sklpos_put(nullsklpos,g3_object->ptrskl);
          if(aniframe[naniframe]==NULL)
            {
            aniframe[naniframe]=g3e_aniframe_new(&g3_object[0]);
            }
          else
            {
            g3_sklpos_get(g3_object[0].ptrskl,aniframe[naniframe]->sklpos);
            }
          waitmouse=1;
          break;
        /*--------------- save anim --------------------------*/
        case 's':
          g3e_ani_save(argv[1],g3_object[0].ptrskl,aniframe,cptaniframe);
          break;
        /*--------------- Load anim -------------------------*/
        case 'l':
          g3e_ani_free(aniframe,cptaniframe);
          g3e_ani_load(argv[1],g3_object[0].ptrskl,aniframe,&cptaniframe);
          naniframe=0;
          break;
        case G3_KEY_SPACE:
          g3_edit_sklaxis+=3;
          if(g3_edit_sklaxis>5) g3_edit_sklaxis-=6;
          break;

        case '4':
        case '6':
        case '8':
        case '2':
        case '7':
        case '9':
        default:
          break;
      }
    }
  while(g3_mouse_getkey()!=G3_KEY_ESC);
  g3_restore();

  /*  g3_timer_restore();*/

  g3e_ani_free(aniframe,cptaniframe);
  g3_free(&aniframe);
  g3_free(&tmpsklpos);
  return(0);
  }





