

#include "g3file.h"



FILE *g3_metafile=NULL;   // metafile handle. IF NULL then we are in multiple file mode (see g3_metafile_open())

SD g3_metafile_open(char *filename)
{
  g3_metafile=fopen(filename,"rb");   //open the metafile
  return(g3_metafile!=NULL);          //return the metafile handle
}

SD g3_metafile_close(void)
{
  SD ret;
  ret=fclose(g3_metafile);      // close the metafile
  g3_metafile=NULL;          // the metafile mode is over
  return(ret);            // return status
}



void g3_fextput(char *path,char *extension,char *rpath)
  {
  char drive[ _MAX_DRIVE ];
  char dir[ _MAX_DIR ];
  char fname[ _MAX_FNAME ];
  char ext[ _MAX_EXT ];
  _splitpath(path,drive,dir,fname,ext);
  _makepath(rpath,drive,dir,fname,extension);
  }

void g3_fnameget(char *path,char *filename)
  {
  char drive[ _MAX_DRIVE ];
  char dir[ _MAX_DIR ];
  char ext[ _MAX_EXT ];
  _splitpath(path,drive,dir,filename,ext);
  }



G3_FILE *g3_fopen(char *filename,char *mode)
{
  G3_FILE *file;
  if(g3_metafile!=NULL)
  {
    //////////////////
    // METAFILE CASE
    //////////////////
    SD lenstr;          // lenght of block name
    SD found;         // flag is block found
    SD start;         // start position of block in metafile
    char name[_MAX_PATH];
    // if not mode RB then error
    if(strcmp(mode,"rb")) return NULL;
    // goto beginning of metafile
    fseek(g3_metafile,0,SEEK_SET);
    // find the file header by name
    fread(&lenstr,sizeof(lenstr),1,g3_metafile);
    found=G3_FALSE;
    while(lenstr>0 && !found)
    {
      //read the block name
      fread(&name,sizeof(char),lenstr,g3_metafile);
      //read the start offset of file
      fread(&start,sizeof(SD),1,g3_metafile);
      //if name of block==filename, it's our block
      if(!strcmp(name,filename))
      {
        // file is found, goto start of block
        fseek(g3_metafile,start,SEEK_SET);
        found=G3_TRUE;
      }
      else
      {
        // not this file...
        fread(&lenstr,sizeof(SD),1,g3_metafile);
      }
    }
    // the file was not found -> error
    if(!found)
      {
      return(NULL);
      }
    // we are ready to read the file data
    // now allocate a G3_FILE handle....
    file=(G3_FILE *)g3_malloc(sizeof(G3_FILE));
    // store the offset in metafile
    file->start=start;
    // store the current offset in block
    file->offset=0;
  }
  else
  {
    //////////////////
    // NORMAL CASE
    //////////////////
    FILE *handle;
    handle=fopen(filename,mode);
    if(handle!=NULL)
    {
      file=(G3_FILE *)g3_malloc(sizeof(G3_FILE));
      file->handle=handle;
    }
    else
    {
      file=NULL;
    }
  }
  return(file);
}

SD g3_fclose(G3_FILE *file)
{
  if(g3_metafile!=NULL)
    {
    //////////////////
    // METAFILE CASE
    //////////////////
    g3_free(file);
    return(0);
    }
  else
    {
    //////////////////
    // METAFILE CASE
    //////////////////
    SD ret;
    ret=fclose(file->handle);
    g3_free(file);
    return(ret);
    }
}

SD g3_fread(void *buffer,SD size,SD count,G3_FILE *file)
{
  if(g3_metafile!=NULL)
    {
    SD ret;
    ret=(fread(buffer,size,count,g3_metafile));
    file->offset+=ret*size;
    return(ret);
    }
  else
    {
    return(fread(buffer,size,count,file->handle));
    }
}

SD g3_fwrite(void *buffer,SD size,SD count,G3_FILE *file)
{
  return(fwrite(buffer,size,count,file->handle));
}

SD g3_fseek(G3_FILE *file,SD offset,SD mode)
{
  return(fseek(file->handle,offset,mode));
}

SD g3_ftell(G3_FILE *file)
{
  return(ftell(file->handle));
}

#if 0

// how to build a METAFILE ?


for n blocks store :
  {
  SD        len (IF 0 then end)
  char[len]   name of block
  SD start    start offset of block (relative to metafile start)
  SD size     size of block
  }
then store each n block

#endif

