

#ifndef _G3FILE_H_
#define _G3FILE_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "g3def.h"
#include "g3malloc.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct
{
  FILE  *handle;    // handle of file if we are not in metafile mode
  SD    start;      // start of block in a metafile
  SD    offset;     // current offset in the metafile's block
  SD    size;     // size of metafile's block
}
G3_FILE;

SD g3_metafile_open(char *filename);
SD g3_metafile_close(void);


void g3_fextput(char *path,char *extension,char *rpath);
void g3_fnameget(char *path,char *filename);
G3_FILE *g3_fopen(char *filename,char *mode);
SD g3_fclose(G3_FILE *file);
SD g3_fread(void *buffer,SD size,SD count,G3_FILE *file);
SD g3_fwrite(void *buffer,SD size,SD count,G3_FILE *file);
SD g3_fseek(G3_FILE *file,SD offset,SD mode);
SD g3_ftell(G3_FILE *file);


#ifdef __cplusplus
}
#endif

#endif




