/************************************************************************/
/*            STANDARD INCLUDES                                         */
/************************************************************************/

#define _G3GRAPH_C_

#include <stdio.h>
#include <stdlib.h>
#include "g3def.h"
#include "g3lib.h"
#include "g3graph.h"
#include "g3file.h"

/************************************************************************/
/*            MACRO FOR POLYGON                                         */
/************************************************************************/


#define G3_TRIANGLECLIPPED(PTRPOLY)\
  {\
  TC tx1,ty1,tx2,ty2;\
  G3_DVERTEX np1,np2;\
  G3_DVERTEX *ptra;\
  G3_DVERTEX *ptrb;\
  G3_DVERTEX *ptrc;\
    ptra=G3_OBJECT_DVERTEXADR(g3_objectdvertex,PTRPOLY->pts1);\
    ptrb=G3_OBJECT_DVERTEXADR(g3_objectdvertex,PTRPOLY->pts2);\
    ptrc=G3_OBJECT_DVERTEXADR(g3_objectdvertex,PTRPOLY->pts3);\
    if(ptra->z>=g3_nearplane)\
    {\
      if(ptrb->z>=g3_nearplane)\
      {\
        if(ptrc->z>=g3_nearplane)\
        {\
          G3_TRIANGLE(ptra,ptrb,ptrc,PTRPOLY->xa,PTRPOLY->ya,PTRPOLY->xb,PTRPOLY->yb,PTRPOLY->xc,PTRPOLY->yc);\
        }\
        else\
        {\
          G3_CLIP3D(ptra,ptrc,PTRPOLY->xa,PTRPOLY->ya,PTRPOLY->xc,PTRPOLY->yc,(&np1),tx1,ty1);\
          G3_CLIP3D(ptrb,ptrc,PTRPOLY->xb,PTRPOLY->yb,PTRPOLY->xc,PTRPOLY->yc,(&np2),tx2,ty2);\
          G3_TRIANGLE(ptra,ptrb,(&np1),PTRPOLY->xa,PTRPOLY->ya,PTRPOLY->xb,PTRPOLY->yb,tx1,ty1);\
          G3_TRIANGLE((&np1),ptrb,(&np2),tx1,ty1,PTRPOLY->xb,PTRPOLY->yb,tx2,ty2);\
        }\
      }\
      else\
      {\
        if(ptrc->z>=g3_nearplane)\
        {\
          G3_CLIP3D(ptrc,ptrb,PTRPOLY->xc,PTRPOLY->yc,PTRPOLY->xb,PTRPOLY->yb,(&np1),tx1,ty1);\
          G3_CLIP3D(ptra,ptrb,PTRPOLY->xa,PTRPOLY->ya,PTRPOLY->xb,PTRPOLY->yb,(&np2),tx2,ty2);\
          G3_TRIANGLE(ptrc,ptra,(&np1),PTRPOLY->xc,PTRPOLY->yc,PTRPOLY->xa,PTRPOLY->ya,tx1,ty1);\
          G3_TRIANGLE(ptra,(&np2),(&np1),PTRPOLY->xa,PTRPOLY->ya,tx2,ty2,tx1,ty1);\
        }\
        else\
        {\
          G3_CLIP3D(ptra,ptrc,PTRPOLY->xa,PTRPOLY->ya,PTRPOLY->xc,PTRPOLY->yc,(&np1),tx1,ty1);\
          G3_CLIP3D(ptra,ptrb,PTRPOLY->xa,PTRPOLY->ya,PTRPOLY->xb,PTRPOLY->yb,(&np2),tx2,ty2);\
          G3_TRIANGLE(ptra,(&np2),(&np1),PTRPOLY->xa,PTRPOLY->ya,tx2,ty2,tx1,ty1);\
        }\
      }\
    }\
    else\
    {\
      if(ptrb->z>=g3_nearplane)\
      {\
        if(ptrc->z>=g3_nearplane)\
        {\
          G3_CLIP3D(ptrb,ptra,PTRPOLY->xb,PTRPOLY->yb,PTRPOLY->xa,PTRPOLY->ya,(&np1),tx1,ty1);\
          G3_CLIP3D(ptrc,ptra,PTRPOLY->xc,PTRPOLY->yc,PTRPOLY->xa,PTRPOLY->ya,(&np2),tx2,ty2);\
          G3_TRIANGLE(ptrb,ptrc,(&np1),PTRPOLY->xb,PTRPOLY->yb,PTRPOLY->xc,PTRPOLY->yc,tx1,ty1);\
          G3_TRIANGLE(ptrc,(&np2),(&np1),PTRPOLY->xc,PTRPOLY->yc,tx2,ty2,tx1,ty1);\
        }\
        else\
        {\
          G3_CLIP3D(ptrb,ptra,PTRPOLY->xb,PTRPOLY->yb,PTRPOLY->xa,PTRPOLY->ya,(&np1),tx1,ty1);\
          G3_CLIP3D(ptrb,ptrc,PTRPOLY->xb,PTRPOLY->yb,PTRPOLY->xc,PTRPOLY->yc,(&np2),tx2,ty2);\
          G3_TRIANGLE(ptrb,(&np2),(&np1),PTRPOLY->xb,PTRPOLY->yb,tx2,ty2,tx1,ty1);\
        }\
      }\
      else\
      {\
        if(ptrc->z>=g3_nearplane)\
        {\
          G3_CLIP3D(ptrc,ptrb,PTRPOLY->xc,PTRPOLY->yc,PTRPOLY->xb,PTRPOLY->yb,(&np1),tx1,ty1);\
          G3_CLIP3D(ptrc,ptra,PTRPOLY->xc,PTRPOLY->yc,PTRPOLY->xa,PTRPOLY->ya,(&np2),tx2,ty2);\
          G3_TRIANGLE((&np1),ptrc,(&np2),tx1,ty1,PTRPOLY->xc,PTRPOLY->yc,tx2,ty2);\
        }\
      }\
    }\
  }

/**************************************************************************/
/*            WINDOW FUNCTIONS                                            */
/**************************************************************************/

void g3_window_clear(SD color)
  {
  SD y;
  SD x;
  DPIXEL *ptrline,*ptr,rcolor;
  ptrline=(DPIXEL *)g3_window_getaddr();
  rcolor=(DPIXEL)color;
  for(y=0;y<g3_ymaxp1;y++)
  {
  ptr=ptrline;  
  for(x=0;x<g3_xmaxp1;x++) *ptr++=rcolor;
  ptrline=(DPIXEL *)((PIXEL *)ptrline+g3_linesize);
  }
  }

/**************************************************************************/
/*            CHAR FUNCTION                                               */
/**************************************************************************/

SD g3_char_getadrwh(PIXEL *font,char c,SD *w,SD *h,PIXEL **ptrdata)
  {
  void *ptr;
  SD offset;
  if(c<32 || c>127) return(G3_FALSE);
  ptr=(void *)font;
  offset=*(((SD *)ptr)+(c-32));
  ptr=(void *)(((SD *)ptr)+(128-32));
  ptr=(void *)(((UB *)ptr)+offset);
  *w=*((UB *)ptr);
  ptr=(void *)(((UB *)ptr)+1);
  *h=*((UB *)ptr);
  ptr=(void *)(((UB *)ptr)+1);
  *ptrdata=(PIXEL *)ptr;
  return(G3_TRUE);
  }

SD g3_char_put(PIXEL *font,SD x,SD y,char c,PIXEL color)
  {
  PIXEL *ptrchar;
  SD w,h,i;
  if(g3_char_getadrwh(font,c,&w,&h,&ptrchar))
    {
    DPIXEL *ptrline,*ptr;
    DPIXEL rcolor;
    rcolor=G3_COLORLIGHT(color & 0xFF,G3_MAXLIGHTING-G3_MAXLIGHTING/4);
    ptrline=(DPIXEL *)(g3_window_getaddr()+g3_yoffset[y]);
    ptrline+=x;
    while(h-->0)
      {
      ptr=ptrline;
      i=w;
      while(i-->0)
        {
        if(*ptrchar) *ptr=rcolor;
        ptrchar++;
        ptr++;
        }
      ptrline=(DPIXEL *)((PIXEL *)ptrline+g3_linesize);
      }
    return(x+w);
    }
  else
    {
    return(x);
    }
  }

SD g3_char_getwh(PIXEL *font,char c,SD *w,SD *h)
  {
  PIXEL *ptrdata;
  return(g3_char_getadrwh(font,c,w,h,&ptrdata));
  }

SD g3_char_getw(PIXEL *font,char c,SD *w)
  {
  PIXEL *ptrdata;
  SD dummy;
  return(g3_char_getadrwh(font,c,w,&dummy,&ptrdata));
  }

SD g3_char_geth(PIXEL *font,char c,SD *h)
  {
  PIXEL *ptrdata;
  SD dummy;
  return(g3_char_getadrwh(font,c,&dummy,h,&ptrdata));
  }

/**************************************************************************/
/*            STRING FUNCTION                                             */
/**************************************************************************/

void g3_string_getwh(PIXEL *font,char *string,SD *tw,SD *th)
  {
  char c;
  SD w,h;
  *tw=0;
  *th=0;
  c=*string++;
  while(c)
    {
    g3_char_getwh(font,c,&w,&h);
    *tw+=w;
    if(h>*th) *th=h;
    c=*string++;
    }
  }

SD g3_string_put(PIXEL *font,SD x,SD y,char *string,PIXEL color)
  {
  char c;
  c=*string++;
  while(c)
    {
    x=g3_char_put(font,x,y,c,color);
    c=*string++;
    }
  return(x);
  }


UB *g3_font_load(char *filename)
  {
  G3_FILE *handle;
  SD size,save;
  UB *buffer;
  buffer=NULL;
  handle=g3_fopen(filename,"rb");
  if(handle!=NULL)
    {
    save=g3_ftell(handle);
    g3_fseek(handle,0L,SEEK_END);
    size=g3_ftell(handle);
    g3_fseek(handle,save,SEEK_SET);
    buffer=(UB *)g3_malloc(size);
    if(buffer!=NULL)
      {
      g3_fread(buffer,1,size,handle);
      }
    g3_fclose(handle);
    };
  return(buffer);
  }


/**************************************************************************/
/*            SPRITE FUNCTION                                             */
/**************************************************************************/

void g3_sprite(PIXEL *srcdata,SD srcx,SD srcy,SD srcw,SD srch,SD dstx,SD dsty)
  {
  SD i;
    PIXEL *sptr;
    DPIXEL *dptr;
    PIXEL *csptr;
    DPIXEL *cdptr;
    if(srcw<=0) return;
    if(srch<=0) return;
    sptr=srcdata+srcx+(srcy<<8);
    dptr=(DPIXEL *)(g3_window_getaddr()+g3_yoffset[dsty]);
    dptr+=dstx;
    do
    {
      csptr=sptr;
      cdptr=dptr;
      i=srcw;
      do
      {
        *cdptr++=G3_COLORLIGHT(*csptr++,G3_MAXLIGHTING-G3_MAXLIGHTING/4);
      }
      while(--i);
      sptr+=256;
      dptr=(DPIXEL *)((PIXEL *)(dptr)+g3_linesize);
    }
    while(--srch);
  }


void g3_sprite_zoom(PIXEL *srcdata,SD srcx,SD srcy,SD srcw,SD srch,SD dstx,SD dsty, SD dstw,SD dsth)
  {
  SD pentex;
  SD pentey;
  SD tmp;
  PIXEL *srcptr;
  PIXEL *dstdata,*dstptr;
  PIXEL pixel;
  SD csrcx;

  /*----pente: nombre de deplt ds source pour 1 pixel dest------------------*/
  pentex=(srcw<<G3_FPSHIFT)/dstw; /* pente des X : precision de G3_GFPSHIFT */
  pentey=(srch<<G3_FPSHIFT)/dsth; /* pente des Y : precision de G3_GFPSHIFT */
  srcx<<=G3_FPSHIFT;              /* x dans la source         */
  srcy<<=G3_FPSHIFT;              /* y dans la source         */

  /*-------------------------------clipping haut----------------------------*/
  if(dsty<0)
    {
    /*------calcul du deplacement dans la source----------*/
    dsth+=dsty;                   /* moins de lignes a afficher */
    if(dsth<0) return;            /* plus de lignes a afficher ?  */
    tmp=(-dsty)*pentey;           /* calcul modification du srcy  */
    srcy+=tmp;                    /* modification srcy    */
    dsty=0;                       /* la destination en y est 0  */
    }
  /*---------------clipping bas----------------------------*/
  tmp=(g3_ymax)-(dsty+dsth);      /* calcul du depassement bas  */
  if(tmp<0)
    {
    dsth+=tmp;                    /* moins de lignes a afficher */
    if(dsth<0) return;            /* plus de lignes a afficher  */
    }
  /*------------------clipping gauche-----------------------*/
  if(dstx<0)
    {
    /*----------------calcul du depassement dans la source--------*/
    dstw+=dstx;                   /* moins de colones a afficher  */
    if(dstw<0) return;            /* plus de colones a afficher ? */
    tmp=(-dstx)*pentex;           /* calcul modification du scrx  */
    srcx+=tmp;
    dstx=0;                       /* la destination en x est 0    */
    }
  /*------------------clipping droit-------------------------*/
  tmp=(g3_xmax)-(dstx+dstw);         /* calcul du depassement a droite */
  if(tmp<0)                       /* si depassement                 */
    {
    dstw+=tmp;                    /* moins de colones a afficher    */
    if(dstw<0) return;            /* plus de colones a afficher     */
    }
  /*-----------------dessin du sprite (verticalement)-----------------------*/
  dstdata=g3_window_getaddr()+g3_yoffset[dsty]+dstx;
  dsth+=dsty;
  if(dsty<dsth)
    {
    do
      {
      dstptr=dstdata;
      srcptr=srcdata+(srcy>>G3_FPSHIFT)*256;
      tmp=dstw;
      csrcx=srcx;
      do
        {
        pixel=*(srcptr+(csrcx>>G3_FPSHIFT));
        if(pixel) *dstptr=pixel;
        dstptr++;
        csrcx+=pentex;
        }
      while(--tmp);
      dstdata+=g3_linesize;
      srcy+=pentey;
      dsty++;
      }
    while(dsty<dsth);
    }
  }

/************************************************************************/
/*              PIXEL FUNCTIONS                                         */
/************************************************************************/

void g3_pixel_put(SD x,SD y,PIXEL color)
  {
  PIXEL *ptr;
  if((UD)x<=g3_xmax && (UD)y<=g3_ymax)
    {
    ptr=g3_window_getaddr()+g3_yoffset[y]+x;
    *ptr=color;
    }
  }

PIXEL g3_pixel_get(SD x,SD y)
  {
  PIXEL *ptr;
  if(x>=0 && x<=g3_xmax && y>=0 && y<=g3_ymax)
    {
    ptr=g3_window_getaddr()+g3_yoffset[y]+x;
    return(*ptr);
    }
  return((PIXEL)(0));
  }

/************************************************************************/
/*              FLAT POLYGON FUNCTIONS                                  */
/************************************************************************/

  #ifdef G3_TRIANGLE
    #undef G3_TRIANGLE
  #endif

#define G3_TRIANGLE(PTRA,PTRB,PTRC,TXA,TYA,TXB,TYB,TXC,TYC)\
  {\
    G3_POLYF_EDGE(PTRA->px,PTRA->py,PTRB->px,PTRB->py);\
    G3_POLYF_EDGE(PTRB->px,PTRB->py,PTRC->px,PTRC->py);\
    G3_POLYF_EDGE(PTRC->px,PTRC->py,PTRA->px,PTRA->py);\
    if(g3_polymaxy-g3_polyminy>0)\
    {\
            G3_POLYF_FILL(G3_COLORLIGHT(ptrpoly->color & 0xFF,G3_MAXLIGHTING-G3_MAXLIGHTING/4));\
    }\
    g3_polyminy=G3_FPMAX;\
    g3_polymaxy=G3_FPMIN;\
  }

#ifdef G3_CLIP3D
#undef G3_CLIP3D
#endif
#define G3_CLIP3D(PTRA,PTRB,TXA,TYA,TXB,TYB,NP,NTX,NTY)\
  {\
        NP->x=g3_clipping3d(PTRB->x,PTRB->z,PTRA->x,PTRA->z);\
        NP->y=g3_clipping3d(PTRB->y,PTRB->z,PTRA->y,PTRA->z);\
        NP->z=g3_nearplane;\
        NP->px=G3_PROJX(NP->x,g3_nearplane);\
        NP->py=G3_PROJY(NP->y,g3_nearplane);\
  }

void g3_polyf_edge(SD xa,SD ya,SD xb,SD yb)
  {
  #define FLAGTEXTURE 0
  #define FLAGLIGHT   0
  #include "g3edge.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  }


void g3_polyf_fill(SD color)
  {
  #define PIXELMACRO  {*ptr=(DPIXEL)(color);}
  #define FLAGTEXTURE 0
  #define FLAGLIGHT   0
  #include "g3fill.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  #undef PIXELMACRO
  }

void g3_polyf(G3_POLYGON *ptrpoly)
  {
    G3_TRIANGLECLIPPED(ptrpoly);
  }



/************************************************************************/
/*      LIGHTENED FLAT POLYGON FUNCTIONS                                */
/************************************************************************/

  #ifdef G3_TRIANGLE
    #undef G3_TRIANGLE
  #endif
#define G3_TRIANGLE(PTRA,PTRB,PTRC,TXA,TYA,TXB,TYB,TXC,TYC)\
  {\
    SD slight;\
    G3_POLYF_EDGE(PTRA->px,PTRA->py,PTRB->px,PTRB->py);\
    G3_POLYF_EDGE(PTRB->px,PTRB->py,PTRC->px,PTRC->py);\
    G3_POLYF_EDGE(PTRC->px,PTRC->py,PTRA->px,PTRA->py);\
    slight=ptra->light+ptrb->light+ptrc->light;\
    slight=G3_DIV3(slight);\
    if(g3_polymaxy-g3_polyminy>0)\
    {\
          G3_POLYF_FILL(G3_COLORLIGHT(ptrpoly->color & 0xFF,slight));\
    }\
    g3_polyminy=G3_FPMAX;\
    g3_polymaxy=G3_FPMIN;\
  }

  #ifdef G3_CLIP3D
    #undef G3_CLIP3D
  #endif
#define G3_CLIP3D(PTRA,PTRB,TXA,TYA,TXB,TYB,NP,NTX,NTY)\
  {\
        NP->x=g3_clipping3d(PTRB->x,PTRB->z,PTRA->x,PTRA->z);\
        NP->y=g3_clipping3d(PTRB->y,PTRB->z,PTRA->y,PTRA->z);\
        NP->z=g3_nearplane;\
        NP->px=G3_PROJX(NP->x,g3_nearplane);\
        NP->py=G3_PROJY(NP->y,g3_nearplane);\
  }


void g3_lpolyf(G3_POLYGON *ptrpoly)
  {
  G3_TRIANGLECLIPPED(ptrpoly);
  }

/************************************************************************/
/*              TEXTURED POLYGONS FUNCTIONS                             */
/************************************************************************/

void g3_polyt_edge(SD xa,SD ya,SD xb,SD yb,SD txa,SD tya,SD txb,SD tyb)
  {
  #define FLAGTEXTURE 1
  #define FLAGLIGHT   0
  #include "g3edge.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  }


void g3_polyt_fill(PIXEL *ptrtexture)
  {
  }

void g3_polyt(G3_POLYGON *ptrpoly)
  {
  }



void g3_lpolyt_fill(PIXEL *ptrtexture,SD light)
  {
  #define PIXELMACRO  {*ptr=G3_COLORLIGHT((*(ptrtexture+(((otyb>>G3_GFPSHIFT)<<8)+(otxb>>G3_GFPSHIFT)))),light);}
  #define FLAGTEXTURE 1
  #define FLAGLIGHT   0
  #include "g3fill.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  #undef PIXELMACRO
  }


void g3_lpolyt(G3_POLYGON *ptrpoly)
  {
  }

/************************************************************************/
/*              TEXTURED GOURAULT POLYGONS FUNCTIONS                    */
/************************************************************************/

  /*
      formulea for affine factor computation :


      (At-Ct)*(By-Cy) - (Bt-Ct)*(Ay-Cy)

  dt/dx = ---------------------------------

          (Ax-Cx)*(By-Cy) - (Bx-Cx)*(Ay-Cy)

    if(ptra->light==ptrb->light && ptrb->light==ptrc->light)\
    {\
        g3_lpolyt(ptrpoly);\
        return;\
    }\

  */

#ifdef G3_TRIANGLE
#undef G3_TRIANGLE
#endif
#define G3_TRIANGLE(PTRA,PTRB,PTRC,TXA,TYA,TXB,TYB,TXC,TYC)\
  {\
    G3_LPOLYTG_EDGE(PTRA->px,PTRA->py,PTRB->px,PTRB->py,TXA,TYA,TXB,TYB,PTRA->light,PTRB->light);\
    G3_LPOLYTG_EDGE(PTRB->px,PTRB->py,PTRC->px,PTRC->py,TXB,TYB,TXC,TYC,PTRB->light,PTRC->light);\
    G3_LPOLYTG_EDGE(PTRC->px,PTRC->py,PTRA->px,PTRA->py,TXC,TYC,TXA,TYA,PTRC->light,PTRA->light);\
    if(g3_polymaxy-g3_polyminy>0)\
    {\
      SD d;\
      d=(PTRA->px-PTRC->px)*(PTRB->py-PTRC->py)-(PTRB->px-PTRC->px)*(PTRA->py-PTRC->py);\
      if(d>0)\
      {\
        g3_pentelight=(((PTRA->light-PTRC->light)*(PTRB->py-PTRC->py)-(PTRB->light-PTRC->light)*(PTRA->py-PTRC->py))<<G3_GFPSHIFT)/d;\
        g3_pentetx=(( (((TXA-TXC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRB->py-PTRC->py)) -(((TXB-TXC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRA->py-PTRC->py)) )/d)<<(G3_GFPSHIFT-G3_FPSHIFT);\
        g3_pentety=(( (((TYA-TYC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRB->py-PTRC->py)) -(((TYB-TYC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRA->py-PTRC->py)) )/d)<<(G3_GFPSHIFT-G3_FPSHIFT);\
          G3_LPOLYTG_FILL(g3_bank[ptrpoly->bank].ptrpixel);\
      }\
    }\
    g3_polyminy=G3_FPMAX;\
    g3_polymaxy=G3_FPMIN;\
  }

  #ifdef G3_CLIP3D
    #undef G3_CLIP3D
  #endif
#define G3_CLIP3D(PTRA,PTRB,TXA,TYA,TXB,TYB,NP,NTX,NTY)\
  {\
        NP->x=g3_clipping3d(PTRB->x,PTRB->z,PTRA->x,PTRA->z);\
        NP->y=g3_clipping3d(PTRB->y,PTRB->z,PTRA->y,PTRA->z);\
        NP->z=g3_nearplane;\
        NP->px=G3_PROJX(NP->x,g3_nearplane);\
        NP->py=G3_PROJY(NP->y,g3_nearplane);\
        NP->light=g3_clipping3d(PTRB->light<<G3_FPSHIFT,PTRB->z,PTRA->light<<G3_FPSHIFT,PTRA->z)>>G3_FPSHIFT;\
        NTX=g3_clipping3d(TXB,PTRB->z,TXA,PTRA->z);\
        NTY=g3_clipping3d(TYB,PTRB->z,TYA,PTRA->z);\
  }




void g3_lpolytg_edge(SD xa,SD ya,SD xb,SD yb,SD txa,SD tya,SD txb,SD tyb,SD lighta,SD lightb)
  {
  #define FLAGTEXTURE 1
  #define FLAGLIGHT   1
  #include "g3edge.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  }


void g3_lpolytg_fill(PIXEL *ptrtexture)
  {
  #define PIXELMACRO {*ptr=G3_COLORLIGHT((*(ptrtexture+((((otyb)>>G3_GFPSHIFT)<<8)+((otxb)>>G3_GFPSHIFT)))),lightb>>G3_GFPSHIFT);}
  #define FLAGTEXTURE 1
  #define FLAGLIGHT   1
  #include "g3fill.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  #undef PIXELMACRO
  }

void g3_lpolytg(G3_POLYGON *ptrpoly)
  {
    G3_TRIANGLECLIPPED(ptrpoly);
  }

void g3_lpolytgry(G3_POLYGON *ptrpoly)
  {
  }

void g3_lpolytgrx(G3_POLYGON *ptrpoly)
  {
  }

void g3_lpolytgrz(G3_POLYGON *ptrpoly)
  {
  }

/************************************************************************/
/*              TEXTURED TRANSPARENT POLYGONS                           */
/************************************************************************/

#ifdef G3_TRIANGLE
#undef G3_TRIANGLE
#endif
#define G3_TRIANGLE(PTRA,PTRB,PTRC,TXA,TYA,TXB,TYB,TXC,TYC)\
  {\
    G3_POLYT_EDGE(PTRA->px,PTRA->py,PTRB->px,PTRB->py,TXA,TYA,TXB,TYB);\
    G3_POLYT_EDGE(PTRB->px,PTRB->py,PTRC->px,PTRC->py,TXB,TYB,TXC,TYC);\
    G3_POLYT_EDGE(PTRC->px,PTRC->py,PTRA->px,PTRA->py,TXC,TYC,TXA,TYA);\
    if(g3_polymaxy-g3_polyminy>0)\
    {\
      SD d;\
      d=(PTRA->px-PTRC->px)*(PTRB->py-PTRC->py)-(PTRB->px-PTRC->px)*(PTRA->py-PTRC->py);\
      if(d>0)\
      {\
        g3_pentetx=(( (((TXA-TXC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRB->py-PTRC->py)) -(((TXB-TXC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRA->py-PTRC->py)) )/d)<<(G3_GFPSHIFT-G3_FPSHIFT);\
        g3_pentety=(( (((TYA-TYC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRB->py-PTRC->py)) -(((TYB-TYC)>>(G3_GFPSHIFT-G3_FPSHIFT))*(PTRA->py-PTRC->py)) )/d)<<(G3_GFPSHIFT-G3_FPSHIFT);\
        G3_POLYTT_FILL(g3_bank[ptrpoly->bank].ptrpixel);\
      }\
    }\
    g3_polyminy=G3_FPMAX;\
    g3_polymaxy=G3_FPMIN;\
  }

#ifdef G3_CLIP3D
#undef G3_CLIP3D
#endif
#define G3_CLIP3D(PTRA,PTRB,TXA,TYA,TXB,TYB,NP,NTX,NTY)\
  {\
        NP->x=g3_clipping3d(PTRB->x,PTRB->z,PTRA->x,PTRA->z);\
        NP->y=g3_clipping3d(PTRB->y,PTRB->z,PTRA->y,PTRA->z);\
        NP->z=g3_nearplane;\
        NP->px=G3_PROJX(NP->x,g3_nearplane);\
        NP->py=G3_PROJY(NP->y,g3_nearplane);\
        NTX=g3_clipping3d(TXB,PTRB->z,TXA,PTRA->z);\
        NTY=g3_clipping3d(TYB,PTRB->z,TYA,PTRA->z);\
  }

void g3_polytt_fill(PIXEL *ptrtexture)
  {
  #define PIXELMACRO \
    {\
      PIXEL pixel;\
      pixel=(*(ptrtexture+((((otyb)>>G3_GFPSHIFT)<<8)+((otxb)>>G3_GFPSHIFT))));\
      if(pixel)\
      {\
        *ptr=G3_COLORLIGHT(pixel,G3_MAXLIGHTING-G3_MAXLIGHTING/4);\
      }\
    }\
    
  #define FLAGTEXTURE 1
  #define FLAGLIGHT   0
  #include "g3fill.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  #undef PIXELMACRO
  }

void g3_polytt(G3_POLYGON *ptrpoly)
  {
    G3_TRIANGLECLIPPED(ptrpoly);
  }

/************************************************************************/
/*         GOURAULD POLYGON FUNCTIONS                                   */
/************************************************************************/

#ifdef G3_TRIANGLE
#undef G3_TRIANGLE
#endif
#define G3_TRIANGLE(PTRA,PTRB,PTRC,TXA,TYA,TXB,TYB,TXC,TYC)\
  {\
    G3_LPOLYG_EDGE(PTRA->px,PTRA->py,PTRB->px,PTRB->py,PTRA->light,PTRB->light);\
    G3_LPOLYG_EDGE(PTRB->px,PTRB->py,PTRC->px,PTRC->py,PTRB->light,PTRC->light);\
    G3_LPOLYG_EDGE(PTRC->px,PTRC->py,PTRA->px,PTRA->py,PTRC->light,PTRA->light);\
    if(g3_polymaxy-g3_polyminy>0)\
    {\
      SD d;\
      d=(PTRA->px-PTRC->px)*(PTRB->py-PTRC->py)-(PTRB->px-PTRC->px)*(PTRA->py-PTRC->py);\
      if(d>0)\
      {\
        g3_pentelight=(((PTRA->light-PTRC->light)*(PTRB->py-PTRC->py)-(PTRB->light-PTRC->light)*(PTRA->py-PTRC->py))<<G3_GFPSHIFT)/d;\
          G3_LPOLYG_FILL(ptrpoly->color & 0xFF);\
      }\
    }\
    g3_polyminy=G3_FPMAX;\
    g3_polymaxy=G3_FPMIN;\
  }

#ifdef G3_CLIP3D
#undef G3_CLIP3D
#endif
#define G3_CLIP3D(PTRA,PTRB,TXA,TYA,TXB,TYB,NP,NTX,NTY)\
  {\
        NP->x=g3_clipping3d(PTRB->x,PTRB->z,PTRA->x,PTRA->z);\
        NP->y=g3_clipping3d(PTRB->y,PTRB->z,PTRA->y,PTRA->z);\
        NP->z=g3_nearplane;\
        NP->px=G3_PROJX(NP->x,g3_nearplane);\
        NP->py=G3_PROJY(NP->y,g3_nearplane);\
        NP->light=g3_clipping3d(PTRB->light<<G3_FPSHIFT,PTRB->z,PTRA->light<<G3_FPSHIFT,PTRA->z)>>G3_FPSHIFT;\
  }

void g3_lpolyg_edge(SD xa,SD ya,SD xb,SD yb,SD lighta,SD lightb)
  {
  #define FLAGTEXTURE 0
  #define FLAGLIGHT   1
  #include "g3edge.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  }


void g3_lpolyg_fill(SD color)
  {
  #define PIXELMACRO  {*ptr=G3_COLORLIGHT(color,lightb>>G3_GFPSHIFT);}
  #define FLAGTEXTURE 0
  #define FLAGLIGHT   1
  #include "g3fill.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  #undef PIXELMACRO
  }

void g3_lpolyg(G3_POLYGON *ptrpoly)
  {
  G3_TRIANGLECLIPPED(ptrpoly);
  }


/************************************************************************/
/*              LIGHTENED TRANSPARENT GOURAULT POLYGON                  */
/************************************************************************/
#ifdef G3_TRIANGLE
  #undef G3_TRIANGLE
#endif
#define G3_TRIANGLE(PTRA,PTRB,PTRC,TXA,TYA,TXB,TYB,TXC,TYC)\
  {\
    G3_LPOLYG_EDGE(PTRA->px,PTRA->py,PTRB->px,PTRB->py,PTRA->light,PTRB->light);\
    G3_LPOLYG_EDGE(PTRB->px,PTRB->py,PTRC->px,PTRC->py,PTRB->light,PTRC->light);\
    G3_LPOLYG_EDGE(PTRC->px,PTRC->py,PTRA->px,PTRA->py,PTRC->light,PTRA->light);\
    if(g3_polymaxy-g3_polyminy>0)\
    {\
      SD d;\
      d=(PTRA->px-PTRC->px)*(PTRB->py-PTRC->py)-(PTRB->px-PTRC->px)*(PTRA->py-PTRC->py);\
      if(d>0)\
      {\
        g3_pentelight=(((PTRA->light-PTRC->light)*(PTRB->py-PTRC->py)-(PTRB->light-PTRC->light)*(PTRA->py-PTRC->py))<<G3_GFPSHIFT)/d;\
        G3_LTPOLYG_FILL(ptrpoly->color & 0xFF);\
      }\
    }\
    g3_polyminy=G3_FPMAX;\
    g3_polymaxy=G3_FPMIN;\
  }

  #ifdef G3_CLIP3D
    #undef G3_CLIP3D
  #endif
#define G3_CLIP3D(PTRA,PTRB,TXA,TYA,TXB,TYB,NP,NTX,NTY)\
  {\
        NP->x=g3_clipping3d(PTRB->x,PTRB->z,PTRA->x,PTRA->z);\
        NP->y=g3_clipping3d(PTRB->y,PTRB->z,PTRA->y,PTRA->z);\
        NP->z=g3_nearplane;\
        NP->px=G3_PROJX(NP->x,g3_nearplane);\
        NP->py=G3_PROJY(NP->y,g3_nearplane);\
        NP->light=g3_clipping3d(PTRB->light<<G3_FPSHIFT,PTRB->z,PTRA->light<<G3_FPSHIFT,PTRA->z)>>G3_FPSHIFT;\
  }


void g3_ltpolyg_fill(SD color)
  {
  #define PIXELMACRO  {*ptr=((*ptr>>1)&g3_halfmask)+((G3_COLORLIGHT(color,lightb>>G3_GFPSHIFT) >>1)&g3_halfmask);}
  #define FLAGTEXTURE 0
  #define FLAGLIGHT   1
  #include "g3fill.c"
  #undef FLAGTEXTURE
  #undef FLAGLIGHT
  #undef PIXELMACRO
  }

void g3_ltpolyg(G3_POLYGON *ptrpoly)
  {
  G3_TRIANGLECLIPPED(ptrpoly);
  }

/************************************************************************/
/*  WIRE POLYGON FUNCTIONS                                              */
/************************************************************************/

#ifdef G3_TRIANGLE
  #undef G3_TRIANGLE
#endif
#define G3_TRIANGLE(PTRA,PTRB,PTRC,TXA,TYA,TXB,TYB,TXC,TYC)\
  {\
    g3_line(PTRA->px,PTRA->py,PTRB->px,PTRB->py,0x0F0F0F0F);\
    g3_line(PTRB->px,PTRB->py,PTRC->px,PTRC->py,0x0F0F0F0F);\
    g3_line(PTRC->px,PTRC->py,PTRA->px,PTRA->py,0x0F0F0F0F);\
  }

  #ifdef G3_CLIP3D
    #undef G3_CLIP3D
  #endif
#define G3_CLIP3D(PTRA,PTRB,TXA,TYA,TXB,TYB,NP,NTX,NTY)\
  {\
        NP->x=g3_clipping3d(PTRB->x,PTRB->z,PTRA->x,PTRA->z);\
        NP->y=g3_clipping3d(PTRB->y,PTRB->z,PTRA->y,PTRA->z);\
        NP->z=g3_nearplane;\
        NP->px=G3_PROJX(NP->x,g3_nearplane);\
        NP->py=G3_PROJY(NP->y,g3_nearplane);\
  }

void g3_polyw(G3_POLYGON *ptrpoly)
  {
  G3_TRIANGLECLIPPED(ptrpoly);    
  }


void g3_polyfw(G3_POLYGON *ptrpoly)
  {
  SD savecolor;
  savecolor=ptrpoly->color;
  ptrpoly->color=0;
  g3_polyf(ptrpoly);
  ptrpoly->color=15;
  g3_polyw(ptrpoly);
  ptrpoly->color=savecolor;
  }

/**************************************************************************/
/*             LINE FUNCTION                                              */
/**************************************************************************/

void g3_line(SD x1,SD y1,SD x2,SD y2,SD color)
 {
 SD k;
 SD dx,dy;
 SD cumul;
 SD ydep;
 DPIXEL *adr;
 DPIXEL rcolor;
      // sort by y
      if (y1>y2)
      {
        cumul=x1;
        x1=x2;
        x2=cumul;
        cumul=y1;
        y1=y2;
        y2=cumul;
      }

      if((y2<0)||(y1>g3_ymax)) return;
      if(y1<0)
      {
        x1+=(y1*(x1-x2))/(y2-y1);
        y1=0;
      }
      if(y2>g3_ymax)
      {
        x2+=((y2-g3_ymax)*(x2-x1))/(y1-y2);
        y2=g3_ymax;
      }

      if (x1>x2)
      {
        cumul=x1;
        x1=x2;
        x2=cumul;
        cumul=y1;
        y1=y2;
        y2=cumul;
      }

      if((x2<0) || (x1>g3_xmax)) return;  /* line out of the screen */
      if(x1<0)
      {
        y1+=(x1*(y1-y2))/(x2-x1);
        x1=0;
      }
      if(x2>g3_xmax)
      {
        y2+= ((x2-g3_xmax)*(y2-y1))/(x1-x2);
        x2 = g3_xmax;
      }
      dx = x2-x1;
      dy = y2-y1;
      ydep = g3_linesize;
      if (dy<0)
      {
        ydep = -g3_linesize;
        dy = -dy;
      }
      adr=(DPIXEL *)(g3_window_getaddr()+g3_yoffset[y1]);
      adr+=x1;
      rcolor=G3_COLORLIGHT(color & 0xFF,G3_MAXLIGHTING-G3_MAXLIGHTING/4);
      if(dx>=dy)
      {
        cumul=(dx>>1);
        k=dx;
        if(!k) return;
        do
        {
          *adr++ = rcolor;
          cumul-=dy;
          if (cumul<0)
          {
            adr=(DPIXEL *)((PIXEL *)adr+ydep);
            cumul+=dx;
          }
        }
        while (--k);
      }
      else
      {
        cumul=(dy>>1);
        k=dy;
        if(!k) return;
        do
        {
          *adr = rcolor;
          adr=(DPIXEL *)((PIXEL *)adr+ydep);
          cumul -= dx;
          if(cumul<dy)
          {
            adr++;
            cumul+=dy;
          }
        }
        while(--k);
      }
    }

void g3_lineh(SD x1,SD y1,SD x2,PIXEL color)
  {
  PIXEL *ptrline;
  SD i;
  if(x2<x1)
    {
    i=x1;
    x1=x2;
    x2=i;
    }
  if(x1>g3_xmax) return;
  if(x2<0) return;
  if(y1>g3_ymax) return;
  if(y1<0) return;
  ptrline=g3_window_getaddr()+g3_yoffset[y1]+x1;
  x2-=x1;
  if(x2>0)
    {
    do
    {
      *ptrline++=color;
    }
    while(--x2);
    }
  }

void g3_linev(SD x1,SD y1,SD y2,PIXEL color)
  {
  PIXEL *ptrline;
  SD i;
  if(y2<y1)
    {
    i=y1;
    y1=y2;
    y2=i;
    }
  if(y1>g3_ymax) return;
  if(y2<0) return;
  if(x1>g3_xmax) return;
  if(x1<0) return;
  ptrline=g3_window_getaddr()+g3_yoffset[y1]+x1;
  y2-=y1;
  if(y2>0)
    {
    do
      {
      *ptrline=color;
      ptrline+=g3_linesize;
      }
    while(--y2);
    }
  }


void g3_rectfill(SD x1,SD y1,SD x2,SD y2,PIXEL color)
  {
  DPIXEL *ptrline,*ptr;
  SD i;
  if(x2<x1)
    {
    i=x1;
    x1=x2;
    x2=i;
    }
  if(y2<y1)
    {
    i=y1;
    y1=y2;
    y2=i;
    }
  if(x1>g3_xmax) return;
  if(x2<0) return;
  if(y1>g3_ymax) return;
  if(y2<0) return;

  if(x1<0) x1=0;
  if(x2>g3_xmax) x2=g3_xmax;
  if(y1<0) y1=0;
  if(y2>g3_ymax) y2=g3_ymax;

  ptrline=(DPIXEL *)(g3_window_getaddr()+g3_yoffset[y1]);
  ptrline+=x1;
  while(y1<=y2)
    {
    ptr=ptrline;
    for(i=x1;i<=x2;i++)
      {
      *ptr++=G3_COLORLIGHT(color & 0xFF,G3_MAXLIGHTING-G3_MAXLIGHTING/4);
      }
    ptrline=(DPIXEL *)((UB *)ptrline+g3_linesize);
    y1++;
    }
  }

void g3_marker(SD x,SD y,PIXEL color)
  {
  g3_pixel_put(x-1,y-2,color);
  g3_pixel_put(x  ,y-2,color);
  g3_pixel_put(x+1,y-2,color);
  g3_pixel_put(x-2,y-1,color);
  g3_pixel_put(x-2,y  ,color);
  g3_pixel_put(x-2,y+1,color);
  g3_pixel_put(x+2,y-1,color);
  g3_pixel_put(x+2,y  ,color);
  g3_pixel_put(x+2,y+1,color);
  g3_pixel_put(x-1,y+2,color);
  g3_pixel_put(x  ,y+2,color);
  g3_pixel_put(x+1,y+2,color);
  }

void g3_rect(SD x1,SD y1,SD x2,SD y2,PIXEL color)
  {
  g3_lineh(x1,y1,x2,color);
  g3_lineh(x1,y2,x2,color);
  g3_linev(x1,y1,y2,color);
  g3_linev(x2,y1,y2,color);
  }

void g3_rectboxed(SD x1,SD y1,SD x2,SD y2,PIXEL color,PIXEL edge)
  {
  g3_rectfill(x1+1,y1+1,x2-1,y2-1,color);
  g3_rect(x1,y1,x2,y2,edge);
  }

void g3_rectlightened(SD x1,SD y1,SD x2,SD y2,PIXEL color,PIXEL edgelightened,PIXEL edgeshadowed)
  {
  g3_rectfill(x1+1,y1+1,x2-1,y2-1,color);
  g3_lineh(x1,y1,x2,edgelightened);
  g3_linev(x1,y1,y2,edgelightened);
  g3_lineh(x1,y2,x2,edgeshadowed);
  g3_linev(x2,y1,y2,edgeshadowed);
  }


