
#ifndef _G3GRAPH_H_
#define _G3GRAPH_H_


/*------------------------------------------------------------------------------*/
/* POLYGON TYPES                                                                */
/*------------------------------------------------------------------------------*/

  #define G3_GRAPHCALL_LEVEL_FULL             0
  #define G3_GRAPHCALL_LEVEL_ALLWIRE          1
  #define G3_GRAPHCALL_LEVEL_ALLFILLEDWIRE    2
  #define G3_GRAPHCALL_LEVEL_ALLFLAT          3
  #define G3_GRAPHCALL_LEVEL_MAX              4

  #ifdef _G3GRAPH_C_
  #define _G3GRAPH_EXTERN_
  #else
  #define _G3GRAPH_EXTERN_ extern
  #endif


  _G3GRAPH_EXTERN_  DPIXEL g3_rmask;
  _G3GRAPH_EXTERN_  DPIXEL g3_gmask;
  _G3GRAPH_EXTERN_  DPIXEL g3_bmask;
  _G3GRAPH_EXTERN_  DPIXEL g3_halfmask;

  _G3GRAPH_EXTERN_ DPIXEL *g3_colorlight;

  _G3GRAPH_EXTERN_ SD g3_graphcall_level;

  _G3GRAPH_EXTERN_ SD g3_videomode;
  _G3GRAPH_EXTERN_ SD g3_oldvideomode;
  _G3GRAPH_EXTERN_ SD g3_highscreen;                    /* we are on high rezolution */
  _G3GRAPH_EXTERN_ SD g3_screenw;                       /* screen width */
  _G3GRAPH_EXTERN_ SD g3_screenh;                       /* screen height */
  _G3GRAPH_EXTERN_ SD g3_xmid;                          /* middle x on screen */
  _G3GRAPH_EXTERN_ SD g3_ymid;                          /* middle y on screen */
  _G3GRAPH_EXTERN_ SD g3_zoomshift;                     /* shift used for zoom */
  _G3GRAPH_EXTERN_ FP g3_xzoom;
  _G3GRAPH_EXTERN_ FP g3_yzoom;
  _G3GRAPH_EXTERN_ PIXEL *g3_scrbuffer;                /* ptr for screen buffer*/
  _G3GRAPH_EXTERN_ PIXEL *g3_cscrbuffer;               /* ptr for screen buffer*/

  _G3GRAPH_EXTERN_ SD g3_windowx;                       /* screen width */
  _G3GRAPH_EXTERN_ SD g3_windowy;                       /* screen height */
  _G3GRAPH_EXTERN_ SD g3_windoww;                       /* screen width */
  _G3GRAPH_EXTERN_ SD g3_windowh;                       /* screen height */

  _G3GRAPH_EXTERN_ SD g3_yoffset[G3_HSCREENH];          /* table of y offsets   */
  _G3GRAPH_EXTERN_ SD g3_tlr[G3_HSCREENH*8];

  _G3GRAPH_EXTERN_ SD g3_polyminy;
  _G3GRAPH_EXTERN_ SD g3_polymaxy;
  _G3GRAPH_EXTERN_ SD g3_linesize;                      /* line size (in byte) */
  _G3GRAPH_EXTERN_ SD g3_pentetx;
  _G3GRAPH_EXTERN_ SD g3_pentety;
  _G3GRAPH_EXTERN_ SD g3_pentelight;
  _G3GRAPH_EXTERN_ SD g3_vfpx;
  _G3GRAPH_EXTERN_ SD g3_vfpy;
  _G3GRAPH_EXTERN_ SD g3_xmax;                          /* x max on screen */
  _G3GRAPH_EXTERN_ SD g3_ymax;                          /* y max on screen */
  _G3GRAPH_EXTERN_ SD g3_xmaxp1;                        /* x max+1 on screen */
  _G3GRAPH_EXTERN_ SD g3_ymaxp1;                        /* y max+1 on screen */
  _G3GRAPH_EXTERN_ SD g3_tmp1;
  _G3GRAPH_EXTERN_ SD g3_tmp2;
  _G3GRAPH_EXTERN_ SD g3_tmp3;
  _G3GRAPH_EXTERN_ SD g3_tmp4;

#endif


