


#ifndef _G3_LAND_H_
#define _G3_LAND_H_

  #include <stdio.h>
  #include <stdlib.h>
  #include <math.h>
  #include <malloc.h>
  #include <string.h>

  #include "g3def.h"
  #include "g3malloc.h"
  #include "g3timer.h"
  #include "g3raw.h"
  #include "g3lib.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct
  {
  UW texture;
  UW htexture;
  SB light;
  UB hlight;
  UB y;
  UB dummy;
  }
G3_LANDITEM;

#define G3_LANDTEXW     64

#define G3_LAND_STEXBNK      8
#define G3_LAND_MTEXBNK      0xFF00

#define G3_LAND_STEXNUM      0
#define G3_LAND_MTEXNUM      0x000F

#define G3_LAND_STEXROT      4
#define G3_LAND_MTEXROT      0x0030

#define G3_LAND_STEXFLIP     6
#define G3_LAND_MTEXFLIP     0x0040



#define G3_LANDSIZESHIFT     (G3_TORESIZESHIFT)                      /* size of complete land */
#define G3_LANDSIZE          (1<<G3_LANDSIZESHIFT)

#define G3_LANDGRIDSTEPSHIFT (G3_TORESTEPSHIFT)                      /* step of grid */
#define G3_LANDGRIDSTEP      (1<<G3_LANDGRIDSTEPSHIFT)

#define G3_GRIDSIZE           32                        /* grid size */

#define G3_LANDYMULTIPLYSHIFT (4)                       /* land y multiplicator */
#define G3_LANDYMULTIPLY      (1<<G3_LANDYMULTIPLYSHIFT)
#define G3_LANDWAVEHEIGHT     (128*G3_LANDYMULTIPLY)


#define G3_LANDWAVEAMPSHIFT   5
#define G3_LANDWAVEAMP        (1<<G3_LANDWAVEAMPSHIFT)


void g3_land_init(void);
void g3_land_free(void);

SD g3_land_load(char *filename);
SD g3_land_save(char *filename);

void g3_land_compute(void);
SD g3_land_gety(SD x,SD z);
void g3_land_getnormal(SD x,SD z,G3_VECTOR *ptrvector);
void g3_land_settexture(SD x,SD z,SD texture);
SD g3_land_gettexture(SD x,SD z);
G3_LANDITEM *g3_land_getlanditemptr(SD x,SD z);
G3_LANDITEM *g3_land_fplandptr(SD x,SD z);
void g3_land_computedvertex(SD x,SD z,G3_DVERTEX *ptrdvertex);
void g3_land_adjust(void);
FP g3_land_getgravityfromy(FP y);
FP g3_land_getsurfacey(void);


#ifdef __cplusplus
}
#endif

#endif

















































