

/************************************************************************/
/*              PCX MANAGEMENT FUNCTION                                 */
/************************************************************************/
  #define _G3_PCX_C_

  #include "g3pcx.h"
  #include "g3error.h"

/************************************************************************/
/*              PRIVATE DEFINITIONS                                     */
/************************************************************************/

typedef struct
{
  UB  fabric;
  UB  version;
  UB  compression;
  UB  nbplanes;

  UW  xmini;
  UW  ymini;

  UW  xmaxi;
  UW  ymaxi;

  UB  dummy[128-3*4];
}
G3_PCXHEADER;

PIXEL *g3_pcx_load(char *filename,SD *w,SD *h)
  {
  SD size;
  G3_FILE *handle;
  G3_PCXHEADER pcxheader;
  SD i;
  PIXEL *cdata,pixel,count;
  PIXEL *data=NULL;
  handle=g3_fopen(filename,"rb");
  if(handle!=NULL)
    {
    g3_fread(&pcxheader,sizeof(pcxheader),1,handle);
    *w=(SD)((UD)(pcxheader.xmaxi-pcxheader.xmini+1));
    *h=(SD)((UD)(pcxheader.ymaxi-pcxheader.ymini+1));
    size=(*w)*(*h)*sizeof(PIXEL);
    cdata=data=(PIXEL *)g3_malloc(size);
		if(data!=NULL)
			{
      // read and decompress the picture
      while(size>0)
      {
        g3_fread(&pixel,sizeof(pixel),1,handle);
        if(pixel<=0x0C0)
        {
          *cdata++=pixel;
          size--;
        }
        else
        {
          count=pixel-0x0C0;
          g3_fread(&pixel,sizeof(pixel),1,handle);
          size-=(SD)((UD)count);
          do
          {
            *cdata++=pixel;
          }
          while(--count);
        }
      }
      // verify format
      g3_fread(&pixel,sizeof(pixel),1,handle);
      // read the palette
      for(i=0;i<G3_MAXCOLOR;i++)
            {
            g3_fread(&g3_colorregister[i],sizeof(G3_COLORREGISTER),1,handle);
            g3_colorregister[i].red>>=2;
            g3_colorregister[i].green>>=2;
            g3_colorregister[i].blue>>=2;
            }
      }
	else
	{
		g3_error("G3_PCX_LOAD : Can't allocate data");
      }
    g3_fclose(handle);
    }
	else
	{
		g3_error("G3_PCX_LOAD : Error while opening PCX file");
    }
	return(data);
  }



