
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>

#include "cdlib.h"

unsigned int  cd_deviceid;
HWND      cd_hwnd;

int CD_open(HWND hwnd)
{
    DWORD dwReturn;
    MCI_OPEN_PARMS mciOpenParms;
    mciOpenParms.lpstrDeviceType="cdaudio";
    if(mciSendCommand(NULL,MCI_OPEN,MCI_OPEN_TYPE,(DWORD)(LPVOID)&mciOpenParms)==0)
  {
    cd_deviceid=mciOpenParms.wDeviceID;
  cd_hwnd=hwnd;
  return(TRUE);
  }
  return(FALSE);
}

void CD_close(void)
{
  mciSendCommand(cd_deviceid,MCI_CLOSE,0,NULL);
}

int CD_pause(void)
{
  mciSendCommand(cd_deviceid,MCI_PAUSE,0,NULL);
}

int CD_stop(void)
{
  mciSendCommand(cd_deviceid,MCI_STOP,0,NULL);
}


int CD_play(void)
{
  mciSendCommand(cd_deviceid,MCI_PLAY,0,NULL);
}


int CD_playtrack(unsigned char bTrack)
{
    DWORD dwReturn;
    MCI_SET_PARMS mciSetParms;
    MCI_PLAY_PARMS mciPlayParms;

    // Set the time format to track/minute/second/frame (TMSF).
    mciSetParms.dwTimeFormat = MCI_FORMAT_TMSF;
    if (dwReturn = mciSendCommand(cd_deviceid, MCI_SET,MCI_SET_TIME_FORMAT,(DWORD)(LPVOID) &mciSetParms))
    {
        mciSendCommand(cd_deviceid, MCI_CLOSE, 0, NULL);
        return (dwReturn);
    } 
    // Begin playback from the given track and play until the beginning 
    // of the next track. The window procedure function for the parent 
    // window will be notified with an MM_MCINOTIFY message when 
    // playback is complete. Unless the play command fails, the window 
    // procedure closes the device.
    mciPlayParms.dwFrom=0L;
    mciPlayParms.dwTo=0L;
    mciPlayParms.dwFrom=MCI_MAKE_TMSF(bTrack,0,0,0);
    mciPlayParms.dwTo=MCI_MAKE_TMSF(bTrack+1,0,0,0);
    mciPlayParms.dwCallback=(DWORD) cd_hwnd;
    dwReturn = mciSendCommand(cd_deviceid, MCI_PLAY,MCI_FROM|MCI_TO|MCI_NOTIFY,(DWORD)(LPVOID)&mciPlayParms);
    return (0L);
}


