

        .386P
        .MODEL SMALL,C
        IDEAL
        SMART
        LOCALS
        JUMPS

 ;------------------------------------------------------------------------------
 ;       DEFINITIONS GLOBALES
 ;------------------------------------------------------------------------------


        G3_FPSHIFT       =       10
        G3_GFPSHIFT      =       16
        G3_TEXSHIFT      =       8

        G3_FPMAX         =       7FFFFFFFh
        G3_FPMIN         =       80000000h

        G3_HSCREENW      =       1024
        G3_HSCREENH      =       768
        G3_HSCREENH4     =       (G3_HSCREENH*4)
        G3_HMAXX         =       (G3_HSCREENW-1)
        G3_HMAXY         =       (G3_HSCREENH-1)
        G3_HMIDX         =       (G3_HSCREENW/2)
        G3_HMIDY         =       (G3_HSCREENH/2)
        G3_HZOOMSHIFT    =       8
        G3_HZOOM         =       256

        G3_SCREENW      =       320
        G3_SCREENH      =       200
        G3_MAXX         =       (G3_SCREENW-1)
        G3_MAXY         =       (G3_SCREENH-1)
        G3_MIDX         =       (G3_SCREENW/2)
        G3_MIDY         =       (G3_SCREENH/2)
        G3_ZOOMSHIFT    =       7
        G3_ZOOM         =       128

        G3_MAXADIVSHIFT =    6
        G3_MAXBDIVSHIFT =    6
        G3_MAXADIV      =    64
        G3_MAXBDIV      =    64


        CODESEG

 ;------------------------------------------------------------------------------
 ;       DEFINITIONS DES STRUCTURES
 ;------------------------------------------------------------------------------

public           asm_begin_
public           asm_end_


 public          g3_polyf_edge_
 public          g3_polyf_fill_

 public          g3_lpolyg_fill_
 public          g3_polyt_fill_
 public          g3_lpolytg_fill_
 public          g3_lpolyt_fill_

 MACRO          JMPFROMSTACK
                db      0c3h
                ENDM

                ALIGN   4
PROC            asm_begin_
                ret
                ENDP asm_begin_
 ;------------------------------------------------------------------------------
 ;       FLAT POLYGON FILL
 ;------------------------------------------------------------------------------
                ALIGN   4
PROC            g3_polyf_edge_
                uses         esi,edi,ebp
                xchg         eax,ebx
                xchg         edx,ecx
                mov          ebp,edx
                ;XA   =       ebx
                ;YA   =       ecx
                ;XB   =       eax
                ;YB   =       ebp
                mov     esi,ebp
                lea     edi,[g3_tlr+G3_HSCREENH*4]
                sub     esi,ecx                         ;esi=DY
                jz      endflatedge                     ;if 0 no edge
                jg      ybsupya                         ;if > 0 right edge
        ybinfya:                                        ;left edge
                neg     esi
                xchg    ebx,eax                         ;swap x
                sub     edi,G3_HSCREENH*4               ;g3_tlr
                xchg    ecx,ebp                         ;swap y
        ybsupya:
                or      ebp,ebp                         ;if yb<0 end
                jl      endflatedge
                cmp     ecx,[g3_ymax]                   ;if ya>g3_ymax end
                jg      endflatedge
                sub     eax,ebx                         ;eax=DX
                sal     eax,G3_FPSHIFT                  ;DX<<=G3_GFPSHIFT
                cdq                                     ;extend to 64 and scratch EDX
                idiv    esi                             ;div by DY

                sal     ebx,G3_FPSHIFT                  ;XA in G3_FPSHIFT prec
                mov     edx,eax                         ;pente
                sar     edx,1                           ;pente/2
                add     ebx,edx                         ;XA+=pente/2
                or      ecx,ecx                         ;clip on top ?
                jl      topclip
        notopclip:
                mov     edx,[g3_ymaxp1]                 ;tmp=g3_ymax+1
                sub     edx,ebp                         ;tmp-=yb
                jl      bottomclip
        nobottomclip:
                cmp     ecx,[g3_polyminy]
                jge     notpolymin
                mov     [g3_polyminy],ecx
        notpolymin:
                cmp     ebp,[g3_polymaxy]
                jle     notpolymax
                mov     [g3_polymaxy],ebp
        notpolymax:
                lea     edi,[edi+ecx*4]

                shr     esi,1
                jz      endflatedge2
                jnc     reppente
                mov     [edi],ebx
                add     edi,4
                add     ebx,eax
        reppente:
                mov     [edi],ebx
                add     ebx,eax
                mov     [edi+4],ebx
                add     ebx,eax
                add     edi,8
                dec     esi
                jnz     reppente
        endflatedge:
                ret
        endflatedge2:
                mov     [edi],ebx
                ret
        topclip:
                add     esi,ecx                         ;dy+=ya
                jle     endflatedge
                mov     edx,ecx                         ;edx=YA
                imul    edx,eax                         ;edx=YA*pente
                sub     ebx,edx                         ;xa-=YA*pente
                xor     ecx,ecx                         ;ya=0

                mov     edx,[g3_ymaxp1]                 ;tmp=g3_ymax+1
                sub     edx,ebp                         ;tmp-=yb
                jge     nobottomclip
        bottomclip:
                add     esi,edx                         ;dy+=tmp
                jle     endflatedge                     ;if < 0 end
                mov     ebp,[g3_ymaxp1]                 ;yb=g3_ymax+1
                jmp     nobottomclip
                ENDP    g3_polyf_edge_

 ;------------------------------------------------------------------------------
 ;       GOURAUD POLYGON FILL
 ;------------------------------------------------------------------------------

                ALIGN   4
PROC            g3_lpolyg_fill_
                uses    ebx,ecx,edx,esi,edi,ebp
                mov     ecx,[g3_polymaxy]
                sub     ecx,[g3_polyminy]                               ;calcul de la hauteur
                jle     @@fin                                           ;si pas de hauteur alors fin
                mov     [g3_polymaxy],ecx                               ;hauteur restante
                mov     ebx,[g3_cscrbuffer]                             ;adresse de l'ecran
                mov     ecx,[g3_polyminy]                               ;ligne de depart
                sal     ecx,2
                add     ebx,[g3_yoffset+ecx]                            ;edi=adresse ligne de depart
                lea     ecx,[g3_tlr+ecx]                                ;ECX=adresse tableau des xa xb
        @@repline:
                mov     ebp,[ecx+G3_HSCREENH*4]                         ;xb
                sar     ebp,G3_FPSHIFT                                 ;xb>>=G3_FPSHIFT
                jle     @@nextline
                mov     [ecx+G3_HSCREENH*4],ebp
                mov     eax,[ecx]                                       ;xa
                sar     eax,G3_FPSHIFT                                 ;xa>>=G3_FPSHIFT
                cmp     eax,[g3_xmax]
                jg      @@nextline
                mov     [ecx],eax                                       ;xa
                sub     ebp,eax                                         ;dx=xb-xa
                jle     @@nextline
                ;calcul de pentecolor
                mov     eax,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]       ;colorb
                sub     eax,[ecx+(G3_HSCREENH+G3_HSCREENH)*4]                   ;colora
                cdq
                idiv    ebp
                mov     esi,eax                                                 ;pentety
                ;clipping droit
                mov     eax,[ecx+G3_HSCREENH*4]
                cmp     eax,[g3_xmaxp1]
                jg      @@clipright
        @@noclipright:
                ;clipping a gauche
                mov     eax,[ecx]                                       ;xa
                test    eax,eax
                jl      @@clipleft
        @@noclipleft:
                mov     ebp,eax
                sub     ebp,[ecx+G3_HSCREENH*4]                         ;xb
                lea     ebp,[@@tfintower+(3-1)+ebp+ebp*2]
                lea     edi,[ebx+eax]
                mov     eax,[ecx+(G3_HSCREENH+G3_HSCREENH)*4]
                ror     eax,G3_GFPSHIFT
                ror     esi,G3_GFPSHIFT
                jmp     ebp
                REPT    G3_HSCREENW
                stosb
                adc     eax,esi
                ENDM
        @@tcomptower:
                stosb
        @@tfintower:
        @@nextline:
                add     ebx,[g3_linesize]
                add     ecx,4
                dec     [g3_polymaxy]
                jnz     @@repline
        @@fin:
                mov     [g3_polymaxy],G3_FPMIN
                mov     [g3_polyminy],G3_FPMAX
                ret
        @@clipright:
                mov     eax,[g3_xmaxp1]
                mov     [ecx+G3_HSCREENH*4],eax
                jmp     @@noclipright
        @@clipleft:
                imul    eax,ebp
                sub     [ecx+(G3_HSCREENH+G3_HSCREENH)*4],eax           ;colora-=oxa*pentecolor;
                xor     eax,eax
                jmp     @@noclipleft
                ENDP    g3_lpolyg_fill_

 ;------------------------------------------------------------------------------
 ;       FLAT TRANSPARENT POLYGON FILL
 ;------------------------------------------------------------------------------
                ALIGN   4
PROC            g3_polyft_fill_
                uses    ebx,ecx,edx,esi,edi,ebp
                mov     ebx,[g3_polyminy]       ;conserver le miny pour la suite
                mov     edx,[g3_polymaxy]
                sub     edx,ebx
                jle     @@fin                     ;if 0 lignes alors fin...
                and     eax,0F0F0F0F0h
                mov     ebp,[g3_cscrbuffer]
                add     ebp,[g3_yoffset+ebx*4]    ;adresse de la ligne
                lea     esi,[g3_tlr+ebx*4]
        @@repline:
                mov     edi,ebp                 ;copie de l'index de la ligne
                mov     ebx,[esi]               ;offset gauche
                sar     ebx,G3_FPSHIFT
                jl      @@clipleft
        @@noclipleft:
                mov     ecx,[esi+G3_HSCREENH*4]  ;xb
                sar     ecx,G3_FPSHIFT
                cmp     ecx,[g3_xmaxp1]
                jg      @@clipright
        @@noclipright:
                sub     ecx,ebx
                jle     @@nextline
                add     edi,ebx
        @@nextcolumn:
                mov     al,[edi]
                and     al,0Fh
                or      al,ah
                stosb
                loop    @@nextcolumn
        @@nextline:
                add     esi,4                   ;passe aux coord suivantes
                add     ebp,[g3_linesize]
                sub     edx,1                   ;une ligne de moins
                jg      @@repline
                jmp     @@fin
        @@clipleft:
                xor     ebx,ebx
                mov     ecx,[esi+G3_HSCREENH*4]  ;offset droit
                sar     ecx,G3_FPSHIFT
                cmp     ecx,[g3_xmaxp1]
                jle     @@noclipright
        @@clipright:
                mov     ecx,[g3_xmaxp1]
                jmp     @@noclipright
        @@fin:
                mov     [g3_polymaxy],G3_FPMIN        ;reinit des min/max
                mov     [g3_polyminy],G3_FPMAX
                ret
                ENDP    g3_polyft_fill_

 ;------------------------------------------------------------------------------
 ;       TEXTURED POLYGON FILL
 ;------------------------------------------------------------------------------
                ALIGN   4
PROC            g3_polyt_fill_
                uses    ebx,ecx,edx,esi,edi,ebp
                mov     ecx,[g3_polymaxy]
                sub     ecx,[g3_polyminy]                               ;calcul de la hauteur
                jle     @@fin                                           ;si pas de hauteur alors fin
                mov     [g3_polymaxy],ecx                               ;hauteur restante
                mov     edi,[g3_cscrbuffer]                             ;adresse de l'ecran
                mov     ecx,[g3_polyminy]                               ;ligne de depart
                sal     ecx,2
                add     edi,[g3_yoffset+ecx]                            ;edi=adresse ligne de depart
                lea     ecx,[g3_tlr+ecx]                                ;ECX=adresse tableau des xa xb
                mov     ebx,eax                                         ;ebx=adresse texture
        @@repline:
                mov     ebp,[ecx+G3_HSCREENH*4]                         ;xb
                sar     ebp,G3_FPSHIFT                                 ;dx>>=G3_FPSHIFT
                jle     @@nextline
                mov     [ecx+G3_HSCREENH*4],ebp

                mov     eax,[ecx]                                       ;xa
                sar     eax,G3_FPSHIFT                                 ;dx>>=G3_GFPSHIFT
                cmp     eax,[g3_xmax]
                jg      @@nextline
                mov     [ecx],eax                                       ;xa
                sub     ebp,eax                                         ;dx=xb-xa
                jle     @@nextline

                ;calcul de pentety

                mov     eax,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]        ;tyb
                sub     eax,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]                    ;tya
                cdq
                idiv    ebp
                mov     esi,eax                                                 ;pentety

                ;calcul de pentetx

                mov     eax,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]       ;txb
                sub     eax,[ecx+(G3_HSCREENH+G3_HSCREENH)*4]                   ;txa
                cdq
                idiv    ebp
                mov     ebp,eax                                                 ;pentetx
                ; clipping droit
                mov     eax,[ecx+G3_HSCREENH*4]
                cmp     eax,[g3_xmaxp1]
                jg      @@clipright
        @@noclipright:
                ;clipping a gauche
                mov     eax,[ecx]                                       ;xa
                or      eax,eax
                jl      @@clipleft
        @@noclipleft:
                push    edi
                add     edi,eax


                ; init pente tx et pente ty

                shr     ebp,G3_GFPSHIFT-G3_TEXSHIFT
                shrd    esi,ebp,G3_GFPSHIFT-G3_TEXSHIFT
                shr     ebp,G3_GFPSHIFT-G3_TEXSHIFT

                ; init txa et tya

                mov     edx,[ecx+(G3_HSCREENH+G3_HSCREENH)*4]                                           ;txa
                shr     edx,G3_GFPSHIFT-G3_TEXSHIFT
                mov     bx,dx
                mov     edx,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]                   ;tya
                shrd    edx,ebx,G3_GFPSHIFT-G3_TEXSHIFT
                shr     bx,G3_GFPSHIFT-G3_TEXSHIFT

                sub     eax,[ecx+G3_HSCREENH*4]                         ;xb
                lea     eax,[eax+4*eax]
                lea     eax,[@@tfintower+eax*2]
                jmp     eax
                REPT    G3_HSCREENW
                mov     bh,dh
                mov     al,[ebx]
                stosb
                add     edx,esi
                adc     bx,bp
                ENDM
        @@tfintower:
                pop     edi
        @@nextline:
                add     edi,[g3_linesize]
                add     ecx,4
                sub     [g3_polymaxy],1
                jg      @@repline
        @@fin:
                mov     [g3_polymaxy],G3_FPMIN
                mov     [g3_polyminy],G3_FPMAX
                ret
        @@clipright:
                mov     eax,[g3_xmaxp1]
                mov     [ecx+G3_HSCREENH*4],eax
                jmp     @@noclipright
        @@clipleft:
                imul    eax,ebp
                sub     [ecx+(G3_HSCREENH+G3_HSCREENH)*4],eax ;otxa-=oxa*pentetx;
                mov     eax,[ecx]                                       ;xa
                imul    eax,esi
                sub     [ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4],eax ;otxa-=oxa*pentetx;
                xor     eax,eax
                jmp     @@noclipleft
                ENDP    g3_polyt_fill_


PROC            g3_lpolytg_fill_
                uses    ebx,ecx,edx,esi,edi,ebp
                ;               31                0
                ;eax :          COLORADDR|LIGH|PIX.
                ;*ebx:          TEX_ADDR.|.Y..|.X..
                ;*ecx:          ...FPX...|.L..|.FPL
                ;g3_vfpx        ..VFPX...|VL..|VFPL
                ;*edx:          ...FPY...|VY..|.VX.
                ;g3_vfpy        ..VFPY...|....|....
                ;edi :          ..DESTINATION ADDR.

                mov     edi,[g3_cscrbuffer]                             ;screen addr
                mov     ebx,[g3_pentety]                                ;pente ty

                shl     ebx,(32-G3_GFPSHIFT)
                mov     ecx,[g3_pentetx]                                ;pente tx

                shl     ecx,(32-G3_GFPSHIFT)
                mov     edx,[g3_pentelight]

                shr     edx,(G3_GFPSHIFT-8)
                mov     [g3_vfpy],ebx
                
                lea     ebp,[@@p_vfpy1-4]
                mov     [ebp],ebx
                lea     ebp,[@@p_vfpy2-4]
                mov     [ebp],ebx
                lea     ebp,[@@p_vfpy3-4]
                mov     [ebp],ebx
                lea     ebp,[@@p_vfpy4-4]
                mov     [ebp],ebx

                mov     cl,dl
                mov     ch,dh

                mov     edx,[g3_polyminy]
                mov     ebx,eax                                         ;ebx=addr texture

                sub     [g3_polymaxy],edx                               ;line count
                mov     ebp,[g3_yoffset+edx*4]                          ;edi=addr screen line

                mov     [g3_vfpx],ecx
                add     edi,ebp

                lea     ebp,[@@p_vfpx1-4]
                mov     [ebp],ecx
                lea     ebp,[@@p_vfpx2-4]
                mov     [ebp],ecx
                lea     ebp,[@@p_vfpx3-4]
                mov     [ebp],ecx
                lea     ebp,[@@p_vfpx4-4]
                mov     [ebp],ecx

                lea     ecx,[g3_tlr+edx*4]
                jmp     @@repline
        @@clipleft:
                xor     ebp,ebp
                jmp     @@noclipleft
        @@clipright:
                mov     edx,eax
                sub     edx,[g3_xmaxp1]
                imul    edx,[g3_pentetx]
                sub     [ecx+G3_HSCREENH4*2],edx

                mov     edx,eax
                sub     edx,[g3_xmaxp1]
                imul    edx,[g3_pentety]
                sub     [ecx+G3_HSCREENH4*3],edx

                mov     edx,eax
                sub     edx,[g3_xmaxp1]
                imul    edx,[g3_pentelight]
                sub     [ecx+G3_HSCREENH4*4],edx

                mov     eax,[g3_xmaxp1]

                jmp     @@noclipright
        @@lineclip:
                add     edi,[g3_linesize]
                add     ecx,4
                dec     [g3_polymaxy]
                jnz     @@repline
                ret
        @@repline:
                mov     edx,[g3_xmaxp1]
                mov     ebp,[ecx]                                       ;xa

                xor     esi,esi
                mov     eax,[ecx+G3_HSCREENH4]                          ;xb

                cmp     ebp,esi
                jl      @@clipleft
        @@noclipleft:
                cmp     eax,edx
                jg      @@clipright
        @@noclipright:
                cmp     ebp,eax
                jge     @@lineclip

                push    edi
                push    ecx

                mov     edx,eax                                     ;compute number of pixel
                sub     edx,ebp
                push    edx
                
                mov     edx,[ecx+G3_HSCREENH4*3]                    ;tya

                lea     ebp,[edi+ebp*2]                             ;left pixel addr
                lea     edi,[edi+eax*2]                             ;right pixel addr

                shl     edx,(32-G3_GFPSHIFT)
                mov     bh,[ecx+G3_HSCREENH4*3+2]                   ;partie entiere de tya

                mov     bl,[ecx+G3_HSCREENH4*2+2]                   ;partie entiere de txa
                
                mov     ebp,ecx
                mov     ecx,[ebp+G3_HSCREENH4*2]                    ;txa

                shl     ecx,(32-G3_GFPSHIFT)
                mov     dh,[byte ptr g3_pentety+2]                  ;variation partie entiere de txa

                mov     dl,[byte ptr g3_pentetx+2]
                mov     ch,[2+ebp+G3_HSCREENH4*4]                   ;lighta

                mov     eax,[g3_colorlight]
                mov     cl,[1+ebp+G3_HSCREENH4*4]                   ;fp light a


                ;               31                0
                ;eax :          COLORADDR|LIGH|PIX.
                ;*ebx:          TEX_ADDR.|.Y..|.X.. OK
                ;*ecx:          ...FPX...|.L..|.FPL
                ;g3_vfpx        ..VFPX...|VL..|VFPL
                ;*edx:          ...FPY...|VY..|.VX. OK
                ;g3_vfpy        ..VFPY...|....|....
                ;edi :          ..DESTINATION ADDR.
                ;ebp :          ..ENDADDR (LEFT PIXEL)
                
                shr     eax,1
                pop     ebp

                cmp     ebp,4
                jle     @@fourpixel
                test    edi,02h
                jz      @@pixel2by2
                ;------------ first non aligned pixel ----------------
        @@firstpixel:
                mov     al,[ebx]                ;1
                sub     edx,12345678
          @@p_vfpy1:
                sbb     bh,dh                   ;1
                mov     ah,ch
                sub     edi,2                   ;1
                sub     ecx,12345678
          @@p_vfpx1:
                sbb     bl,dl                   ;2
                mov     si,[eax+eax]
                mov     [edi],si                ;2
                dec     ebp
                ;----------------2 by 2 pixels ------------------------
        @@pixel2by2:        
                push    ebp
                shr     ebp,1
        @@reppixel:
                mov     al,[ebx]                ;1
                sub     edx,12345678
          @@p_vfpy2:
                sbb     bh,dh                   ;1
                mov     ah,ch
                sub     edi,4                   ;1
                sub     ecx,12345678
          @@p_vfpx2:
                sbb     bl,dl                   ;2
                mov     si,[eax+eax]
                shl     esi,16                  ;2
                mov     al,[ebx]                ;1
                sub     edx,12345678
          @@p_vfpy3:
                sbb     bh,dh                   ;1
                mov     ah,ch
                sub     ecx,12345678
          @@p_vfpx3:
                sbb     bl,dl                   ;2
                mov     si,[eax+eax]
                mov     [edi],esi               ;2
                dec     ebp
                jg     @@reppixel
                ;------------------ little segment or last pixel----------------------------------
                pop     ebp
                and     ebp,1
                jz      @@nextline
        @@fourpixel:
                mov     al,[ebx]                ;1
                sub     edx,12345678
          @@p_vfpy4:
                sbb     bh,dh                   ;1
                mov     ah,ch
                sub     edi,2                   ;1
                sub     ecx,12345678
          @@p_vfpx4:
                sbb     bl,dl                   ;2
                mov     si,[eax+eax]
                mov     [edi],si                ;2
                dec     ebp
                jg     @@fourpixel             ;1
          @@nextline:      
                pop     ecx
                pop     edi
                add     edi,[g3_linesize]
                add     ecx,4
                dec     [g3_polymaxy]
                jnz     @@repline
                ret
                ENDP    g3_lpolytg_fill_

 ;------------------------------------------------------------------------------
 ;       TEXTURED POLYGON FILL LIGHT
 ;------------------------------------------------------------------------------
                ALIGN   4
PROC            g3_lpolyt_fill_
                uses    ebx,ecx,esi,edi,ebp
                mov     ecx,[g3_polymaxy]
                sub     ecx,[g3_polyminy]                               ;calcul de la hauteur
                jle     @@fin                                           ;si pas de hauteur alors fin
                mov     [g3_polymaxy],ecx                               ;hauteur restante
                mov     edi,[g3_cscrbuffer]                             ;adresse de l'ecran
                mov     ecx,[g3_polyminy]                               ;ligne de depart
                sal     ecx,2
                add     edi,[g3_yoffset+ecx]                            ;edi=adresse ligne de depart
                lea     ecx,[g3_tlr+ecx]                                ;ECX=adresse tableau des xa xb
                mov     ebx,eax                                         ;ebx=adresse texture
                mov     [g3_pentelight],edx
        @@repline:
                mov     ebp,[ecx+G3_HSCREENH*4]                         ;xb
                sar     ebp,G3_FPSHIFT                                 ;dx>>=G3_FPSHIFT
                jle     @@nextline
                mov     [ecx+G3_HSCREENH*4],ebp

                mov     eax,[ecx]                                       ;xa
                sar     eax,G3_FPSHIFT                                 ;dx>>=G3_FPSHIFT
                cmp     eax,[g3_xmax]
                jg      @@nextline
                mov     [ecx],eax                                       ;xa
                sub     ebp,eax                                         ;dx=xb-xa
                jle     @@nextline

                ;calcul de pentety

                mov     eax,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]        ;tyb
                sub     eax,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]                    ;tya
                cdq
                idiv    ebp
                mov     esi,eax                                                 ;pentety

                ;calcul de pentetx

                mov     eax,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]       ;txb
                sub     eax,[ecx+(G3_HSCREENH+G3_HSCREENH)*4]                   ;txa
                cdq
                idiv    ebp
                mov     ebp,eax                                                 ;pentetx

                ; clipping droit

                mov     eax,[ecx+G3_HSCREENH*4]
                cmp     eax,[g3_xmaxp1]
                jg      @@clipright
        @@noclipright:

                ;clipping a gauche
                mov     eax,[ecx]                                       ;xa
                or      eax,eax
                jl      @@clipleft
        @@noclipleft:
                push    edi
                add     edi,eax

                ; init pente tx et pente ty

                shr     ebp,G3_GFPSHIFT-G3_TEXSHIFT
                shrd    esi,ebp,G3_GFPSHIFT-G3_TEXSHIFT
                shr     ebp,G3_GFPSHIFT-G3_TEXSHIFT

                ; init txa et tya

                mov     edx,[ecx+(G3_HSCREENH+G3_HSCREENH)*4]                                           ;txa
                shr     edx,G3_GFPSHIFT-G3_TEXSHIFT
                mov     bx,dx
                mov     edx,[ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4]                   ;tya
                shrd    edx,ebx,G3_GFPSHIFT-G3_TEXSHIFT
                shr     bx,G3_GFPSHIFT-G3_TEXSHIFT


                sub     eax,[ecx+G3_HSCREENH*4]                         ;xb
                lea     eax,[eax+2*eax]
                lea     eax,[@@tfintower+eax*4]
                push    eax
                mov     eax,[g3_pentelight]
                shl     eax,8
                and     eax,00000FF00h
                add     eax,[g3_colorlight]
                JMPFROMSTACK
                REPT    G3_HSCREENW
                mov     bh,dh
                mov     al,[ebx]
                mov     al,[eax]
                stosb
                add     edx,esi
                adc     bx,bp
                ENDM
        @@tfintower:
                pop     edi
        @@nextline:
                add     edi,[g3_linesize]
                add     ecx,4
                dec     [g3_polymaxy]
                jg      @@repline
        @@fin:
                mov     [g3_polymaxy],G3_FPMIN
                mov     [g3_polyminy],G3_FPMAX
                ret
        @@clipright:
                mov     eax,[g3_xmaxp1]
                mov     [ecx+G3_HSCREENH*4],eax
                jmp     @@noclipright
        @@clipleft:
                imul    eax,ebp
                sub     [ecx+(G3_HSCREENH+G3_HSCREENH)*4],eax ;otxa-=oxa*pentetx;
                mov     eax,[ecx]                                       ;xa
                imul    eax,esi
                sub     [ecx+(G3_HSCREENH+G3_HSCREENH+G3_HSCREENH+G3_HSCREENH)*4],eax ;otya-=oya*pentetx;
                xor     eax,eax
                jmp     @@noclipleft
                ENDP    g3_lpolyt_fill_


                ALIGN   4
PROC            g3_polyf_fill_
                uses    ebx,ecx,edx,esi,edi,ebp
                mov     ebx,[g3_polyminy]       ;conserver le miny pour la suite
                mov     ecx,eax
                shl     eax,16
                mov     edx,[g3_polymaxy]
                mov     ebp,[g3_cscrbuffer]
                sub     edx,ebx
                and     ecx,0FFFFh
                lea     esi,[g3_tlr+ebx*4]        ;g3_tlr
                add     ebp,[g3_yoffset+ebx*4]    ;adresse de la ligne
                or      eax,ecx
        @@repline:
                mov     ebx,[esi]               ;offset gauche
                mov     edi,ebp                 ;copie de l'index de la ligne
                cmp     ebx,0
                jl      @@clipleft
        @@noclipleft:
                mov     ecx,[esi+G3_HSCREENH4]  ;offset droit
                lea     edi,[edi+ebx*2]
                cmp     ecx,[g3_xmaxp1]
                jg      @@clipright
        @@noclipright:
                sub     ecx,ebx
                jle     @@nextline
                test    edi,02
                je      @@nocal
                mov     [edi],ax
                add     edi,2
                dec     ecx
        @@nocal:
                sar     ecx,1
                rep     stosd
                adc     ecx,ecx
                rep     stosw
        @@nextline:
                add     esi,4                   ;passe aux coord suivantes
                add     ebp,[g3_linesize]
                dec     edx                     ;une ligne de moins
                jnz     @@repline
        @@fin:
                ret
        @@clipleft:
                xor     ebx,ebx
                jmp     @@noclipleft
        @@clipright:
                mov     ecx,[g3_xmaxp1]
                jmp     @@noclipright
                ENDP    g3_polyf_fill_



                ALIGN   4
PROC            asm_end_
                ret
                ENDP asm_end_
                

 ;------------------------------------------------------------------------------
 ;       DISPLAY A LINE
 ;------------------------------------------------------------------------------

        DATASEG


 EXTRN         g3_tmp1:DWORD
 EXTRN         g3_tmp2:DWORD
 EXTRN         g3_tmp3:DWORD
 EXTRN         g3_tmp4:DWORD
 EXTRN         g3_pentetx:DWORD
 EXTRN         g3_pentety:DWORD
 EXTRN         g3_pentelight:DWORD
 EXTRN         g3_vfpx:DWORD
 EXTRN         g3_vfpy:DWORD
 EXTRN         g3_pentety:DWORD
 EXTRN         g3_cscrbuffer:DWORD
 EXTRN         g3_yoffset:DWORD
 EXTRN         g3_colorlight:DWORD
 EXTRN         g3_tlr:DWORD
 EXTRN         g3_polyminy:DWORD
 EXTRN         g3_polymaxy:DWORD
 EXTRN         g3_linesize:DWORD
 EXTRN         g3_xmax:DWORD
 EXTRN         g3_ymax:DWORD
 EXTRN         g3_xmaxp1:DWORD
 EXTRN         g3_ymaxp1:DWORD
                END
                
                
                
                
