//-----------------------------------------------------------------------------
// (C) 1997	L.C
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------


#ifndef _G3DEF_H_
#define _G3DEF_H_

/*------------------------------------------------------------------------------*/
/* STANDARD TYPE DEFINITIONS                                                    */
/*------------------------------------------------------------------------------*/
  typedef signed short int SW;
  typedef unsigned short int UW;
  typedef signed int SD;
  typedef unsigned int UD;
  typedef signed char SB;
  typedef unsigned char UB;
  typedef unsigned char PIXEL;
  typedef unsigned short DPIXEL;
  typedef unsigned int VERTEXINDEX;
  typedef signed int TC;                      // texture coordinate

/*------------------------------------------------------------------------------*/
/* GLOBAL DEFINITIONS                                                           */
/*------------------------------------------------------------------------------*/
  #define G3_DEBUG
  #define G3_EDITOR
  #define G3_FLOAT      0
  #define G3_TEXSHIFT   8

  // world tore definitions
  
  #define G3_TORESIZESHIFT  8
  #define G3_TORESTEPSHIFT  7
  #define G3_TORESIZE       (1<<G3_TORESIZESHIFT)
  #define G3_TORESTEP       (1<<G3_TORESTEPSHIFT)

  #define G3_TORE_RELATIVEXYZ(BASEX,BASEY,BASEZ,X,Y,Z,RX,RY,RZ)\
  {\
    RX=(X-BASEX) & ((1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT))-1);\
    RY=(Y-BASEY);\
    RZ=(Z-BASEZ) & ((1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT))-1);\
    if( RX>(1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT-1))) RX-=(1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT));\
    if( RZ>(1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT-1))) RZ-=(1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT));\
  }\

  #define G3_TORE_MASKXYZ(X,Y,Z,RX,RY,RZ)\
  {\
    RX=(X) & ((1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT))-1);\
    RY=(Y);\
    RZ=(Z) & ((1<<(G3_TORESIZESHIFT+G3_TORESTEPSHIFT+G3_FPSHIFT))-1);\
  }\

  //graphic 2d precision
  #define G3_GFPSHIFT   16
  #define G3_GFPUNIT     ((SD)(1)<<G3_GFPSHIFT)
  #define G3_GFPVALUE(a) ((SD)((a)*(1<<G3_GFPSHIFT)))

  #define G3_MIN(a,b) (((a)<=(b)) ? (a):(b))
  #define G3_MAX(a,b) (((a)>=(b)) ? (a):(b))
  #define G3_MIN3(a,b,c) (G3_MIN(a,G3_MIN(b,c)))
  #define G3_MAX3(a,b,c) (G3_MAX(a,G3_MAX(b,c))) 
  #define G3_TRUE (0==0)
  #define G3_FALSE (0!=0)
  //fixed point precision
  #define G3_FPSHIFT    10
  SD fpqmuls(SD a,SD b);
  SD fpqdivs(SD a,SD b);
  SD fpqmulsprec(SD a,SD b,SD c);
  SD fpqdivsprec(SD a,SD b,SD c);


  #pragma aux fpqmuls=""                \
        "imul  edx"                     \
        "shrd  eax,edx,10"              \
        parm [eax] [edx] modify [eax edx] value [eax];


  #pragma aux fpqmulsprec=""                \
        "mov     ecx,edx"\
        "cdq"\
        "imul    ecx"\
        "mov     ecx,ebx"\
        "shrd    eax,edx,cl"\
        parm [eax] [edx] [ebx] modify [eax edx ecx ebx] value [eax];

  #pragma aux fpqdivs=""                \
        "mov   ecx,edx"                 \
        "cdq"                           \
        "shld  edx,eax,10"              \
        "shl   eax,10"                  \
        "idiv  ecx"                     \
        parm [eax] [edx] modify [eax edx ecx] value [eax];

  #if G3_FLOAT
    typedef float FP;
    #define G3_FPUNIT     (1.0)
    #define G3_FPVALUE(a) (a)
    #define G3_FPMAX      (99999999999999999.0)
    #define G3_FPMIN      (-99999999999999999.0)
    #define G3_FPMULS(A,B)    ((A)*(B))
    #define G3_FPDIVS(A,B)    ((A)/(B))
    #define G3_FPMULSPREC(A,B,C)    ((A)*(B))
    #define G3_FPSHIFTR(A,B)  (A)
    #define G3_FPSHIFTL(A,B)  (A)
    #define G3_FPSQRT(A)  (sqrt(A))
    #define G3_FPREAD(A,B)\
    {\
    SD tmp;\
    g3_fread(&tmp,sizeof(tmp),1,B);\
    A=((float)(tmp))*(1/(1<<10));\
    }
    #define G3_FPWRITE(A,B)\
    {\
    SD tmp;\
    tmp=((SD)(A*(1<<G3_FPSHIFT)))>>(G3_FPSHIFT-10);\
    g3_fwrite(&tmp,sizeof(tmp),1,B);\
    }
  #else
    typedef int FP;  
    #define G3_FPUNIT     ((SD)(1)<<G3_FPSHIFT)
    #define G3_FPVALUE(a) ((SD)((a)*(1<<G3_FPSHIFT)))
    #define G3_FPMAX      (0x7FFFFFFF)
    #define G3_FPMIN      (0x80000000)
    #define G3_FPMULS(A,B)    (fpqmuls(A,B))
    #define G3_FPMULSPREC(A,B,C) (fpqmulsprec(A,B,C))
    #define G3_FPDIVS(A,B)    (fpqdivs(A,B))
    #define G3_FPSHIFTR(A,B)  ((A)>>(B))
    #define G3_FPSHIFTL(A,B)  ((A)<<(B))
    #define G3_FPSQRT(A)  (g3_dwordsqrt(A))
    #define G3_FPREAD(A,B)\
    {\
    SD tmp;\
    g3_fread(&tmp,sizeof(tmp),1,B);\
    A=tmp<<(G3_FPSHIFT-10);\
    }
    #define G3_FPWRITE(A,B)\
    {\
    SD tmp;\
    tmp=(A)>>(G3_FPSHIFT-10);\
    g3_fwrite(&tmp,sizeof(tmp),1,B);\
    }
  #endif
  #define G3_FPEPSILON G3_FPVALUE(0.05)
  #define G3_FPZERO G3_FPVALUE(0)
  #define G3_FPSWAP(A,B)\
  {\
    FP tmp;\
    tmp=A;\
    A=B;\
    B=tmp;\
  }\


/*------------------------------------------------------------------------------*/
/* GLOBAL STRUCTURES                                                            */
/*------------------------------------------------------------------------------*/

  typedef struct
    {
    FP m11,m12,m13;
    FP m21,m22,m23;
    FP m31,m32,m33;
    FP m41,m42,m43;
    }
  G3_MATRIX;

  typedef struct
    {
    SD flag;         /* flag for end vertex list */
    //G3_VECTOR vector;
    FP x;            /* x position               */
    FP y;            /* y position               */
    FP z;            /* z position               */
    FP xy;           /* x * y                    */
    //G3_VECTOR normal;
    FP nx;           /* x normal comp            */
    FP ny;           /* y normal comp            */
    FP nz;           /* z normal comp            */
    }
  G3_VERTEX;

  typedef struct
    {
    SD x;            /* angle for x axis         */
    SD y;            /* angle for y axis         */
    SD z;            /* angle for z axis         */
    }
  G3_ROTATION;

  typedef struct
    {
    FP x;
    FP y;
    FP z;
    }
  G3_VECTOR;

  typedef struct
    {
    G3_ROTATION     rotation;     /* current rotation                 */
    G3_VECTOR  translation;  /* current translation              */
    }
  G3_SKLPOS;

  typedef struct
    {
    G3_SKLPOS *sklpos;
    SD nbframe;                /* nbframe of sklpos               */
    SD blockedskl;            /* num of blocked skl (-1 if none) */
    SD dummy1;
    SD dummy2;
    SD dummy3;
    SD dummy4;
    SD dummy5;
    SD dummy6;
    SD dummy7;
    SD dummy8;
    }
  G3_ANIFRAME;

  typedef struct
    {
    FP x;            /* final x position               */
    FP y;            /* final y position               */
    FP z;            /* final z position               */
    SD px;           /* projected x                    */
    SD py;           /* projected y                    */
    }
  G3_TARGETDVERTEX;

  typedef struct
    {
    SD recurse;                 /* recursion level                */
    G3_VECTOR  translation;     /* translation                    */
    G3_ROTATION     rotation;   /* current rotation               */
    G3_VECTOR  dtranslation;    /* translation variation factor   */
    G3_ROTATION     drotation;  /* rotation variation factor      */
    G3_MATRIX       matrix;     /* matrix of current skl         */
    G3_VECTOR  target;          /* current target                 */
    G3_VECTOR  dtarget;         /* dst target of sklitem in space    */
    G3_VECTOR  starget;         /* src target of sklitem in space    */
    G3_TARGETDVERTEX ddtarget;  /* dst target of sklitem in screen   */
    G3_TARGETDVERTEX dstarget;  /* src target of sklitem             */
    }
  G3_SKL;

  typedef struct
    {
    FP x;            /* final x position               */
    FP y;            /* final y position               */
    FP z;            /* final z position               */
    SD px;           /* projected x                    */
    SD py;           /* projected y                    */
    SD light;
    union
    {
    G3_SKL *ptrskl;
    SD  height;
    };
    G3_VERTEX *ptrvertex;
    }
  G3_DVERTEX;

  typedef struct
    {
    SD type;
    SD color;
    VERTEXINDEX pts1;
    VERTEXINDEX pts2;
    VERTEXINDEX pts3;
    SD bank;
    TC xa,ya;
    TC xb,yb;
    TC xc,yc;
    }
  G3_POLYGON;

  typedef void (*G3_FUNCTION)(G3_POLYGON *);

  typedef struct
  {
    char            name[256];
    G3_SKL          *ptrskl;          /* pointer on current skl         */
    G3_VERTEX       *ptrvertex;       /* pointer on vertex list         */
    G3_POLYGON      *ptrpoly;         /* pointer on polygon list        */
  }
  G3_SHAPE;

  typedef void (*G3_FUNCOBJECT)(void *ptrobject,int codestm);

  typedef struct _g3_object
  {
  G3_VECTOR       oldtranslation;   /* world old position of object          */
  G3_VECTOR       translation;      /* world position of object              */
  G3_ROTATION     oldrotation;      /* world old rotation of object          */
  G3_ROTATION     rotation;         /* wordl rotation of object              */

  G3_VECTOR       vtranslation;     /* local speed of translation            */
  G3_ROTATION     vrotation;        /* local speed of rotation               */

  G3_VECTOR       wvtranslation;    /* world speed of translation            */
  G3_VECTOR       wvcollid;         /* world speed of collision              */
  
  G3_VECTOR       wspeed;           /* world global speed                    */
  G3_VECTOR       collidray;        /* rays of collision cube                */
                                    /* note : if ray==0 then no collid possible */

  FP              vgravity;
  
  struct _g3_object      *creator;         /* ADDR of the creator         */
  struct _g3_object      *destructor;      /* ADDR of the destructor      */
  struct _g3_object      *goal;            /* ADDR of the goal            */

  SD              collidgroup;
  
  
  FP              scale;

  SD              ray;              /* ray of the bounding cube       */

  SD              power;            /* power of destruction           */
  SD              life;             /* life                           */
  SD              time;             /* time                           */
  SD              firetime;         /* time                           */
  SD              motiontime;       /* time for skl motion            */
  G3_MATRIX       matrix;           /* current matrix of this object  */

  SD              canrun;           /* function STM_RUN called        */
  G3_FUNCOBJECT   function;         /* management function of object  */
  SD              detail;           /* level of detail                */
  G3_SKL          *ptrskl;          /* pointer on current skl         */
  G3_VERTEX       *ptrvertex;       /* pointer on vertex list         */
  G3_POLYGON      *ptrpoly;         /* pointer on polygon list        */
  G3_SKLPOS       *sklpos;          /* pointer on sklpos to go        */
  SD              framecount;       /* count of frame to terminate    */
  G3_DVERTEX      *dvertex;         /* pointer on start dvertex adr   */
  G3_SKL          *ptrblockedskl;   /* pointer on blocked skl        */
  G3_VECTOR       mintarget;
  G3_VECTOR       maxtarget;
  G3_VECTOR       adjust;
  SD              cargo[8];
  SD              sddummy[8];
  UB              ubdummy[8];
  }
  G3_OBJECT;


  typedef struct
    {
    SD w;
    SD h;
    PIXEL *data;
    }
  G3_SPRITE;

  typedef struct
    {
    UB red;
    UB green;
    UB blue;
    }
  G3_COLORREGISTER;

  struct g3_otitem_s
    {
    SD type;
    struct g3_otitem_s *next;
    G3_POLYGON *ptr;
    G3_DVERTEX *ptrdvertex;
    };
  typedef struct g3_otitem_s G3_OTITEM;

  typedef struct
    {
    G3_VECTOR    translation;
    G3_ROTATION       rotation;
    G3_MATRIX         matrix;
    G3_MATRIX         invmatrix;
    G3_MATRIX         andinvmatrix;
    }
  G3_CAMERA;

  typedef struct
    {
    FP sin;
    FP cos;
    }
  G3_SINCOS;

  typedef struct
    {
    PIXEL             *ptrpixel;
    }
  G3_BANK;

/*------------------------------------------------------------------------------*/
/*  SCREEN DEFINITIONS                                                          */
/*------------------------------------------------------------------------------*/

  /*------- set for hightest video mode -----------------*/
  #define G3_HSCREENW    1024             /*                            */
  #define G3_HSCREENH    768              /*                            */
  #define G3_HMAXX     (G3_HSCREENW-1)    /*                            */
  #define G3_HMAXY     (G3_HSCREENH-1)    /* coordonnee y max           */
  #define G3_HMIDX     (G3_HSCREENW/2)    /* coordonnees x milieu ecran */
  #define G3_HMIDY     (G3_HSCREENH/2)    /* coordonnees y milieu ecran */
  #define G3_HZOOMSHIFT 9                 /* shift value of the zoom    */
  #define G3_HZOOM     ((SD)(1)<<G3_HZOOMSHIFT)     /* value of the zoom          */
  /*------- set for lowest video mode -------------------*/
  #define G3_SCREENW    320             /*                            */
  #define G3_SCREENH    200             /*                            */
  #define G3_MAXX     (G3_SCREENW-1)    /*                            */
  #define G3_MAXY     (G3_SCREENH-1)    /* coordonnee y maximale      */
  #define G3_MIDX     (G3_SCREENW/2)    /* coordonnees x milieu ecran */
  #define G3_MIDY     (G3_SCREENH/2)    /* coordonnees y milieu ecran */
  #define G3_ZOOMSHIFT 8                /* shift value of the zoom    */
  #define G3_ZOOM     ((SD)(1)<<G3_ZOOMSHIFT)      /* value of the zoom          */



/*------------------------------------------------------------------------------*/
/* 3D DEFINITIONS                                                               */
/*------------------------------------------------------------------------------*/


  #define G3_GRAVITY          (G3_FPVALUE(-0.01))

  #define G3_MAXLIGHTINGSHIFT 7
  #define G3_MAXLIGHTING      (1<<G3_MAXLIGHTINGSHIFT)    /* maximum lighting value */


  #define G3_MAXCOLORSHIFT 8
  #define G3_MAXCOLOR   (1<<G3_MAXCOLORSHIFT)             /* maximum count of color used */

  #define G3_MAXBANKSHIFT 4                 /* max bank                   */
  #define G3_MAXBANK    (1<<G3_MAXBANKSHIFT)/* max bank                   */
  #define G3_MAXVERTEX  8192                /* max vertex                 */
  #define G3_MAXCAMERA  16                  /* max camera                 */
  #define G3_MAXSHAPE   512
  #define G3_MAXOBJECT  512                 /* max object available        */
  #define G3_MAXPARTICLE  256               /* max particle available        */

  #define G3_MAXPOLY    2048                /* max elem for sort          */
  #define G3_MAXSUBPOLY 2048                /* max subdivide polygon      */
  #define G3_PI         3.14159265358269    /* no comment....             */
  #define G3_RADIAN(x)  ((float)(G3_PI*2*x)/G3_NBANGLE)      /* conversion deg -> rad      */

  #define G3_NBANGLESHIFT 12                /* shift for count of angle   */
  #define G3_NBANGLE    (1<<G3_NBANGLESHIFT) /* count of angles            */
  #define G3_DEPTHSHIFT 4                             /* shift value of the depth   */
  #define G3_DEPTH      ((SD)(1)<<G3_DEPTHSHIFT)   /* value of the depth         */
  #define G3_ENDMARK    (-1)
  #define G3_CLIPDIST   (G3_FPVALUE(1))

  #define G3_OTMAX      4096

/*------------------------------------------------------------------------------*/
/*  MACROS DEFINITIONS                                                          */
/*------------------------------------------------------------------------------*/

  #define G3_FPANGLE(A)     ((SD)((A)*(1<<G3_FPSHIFT)))
  #define G3_ANGLE(A)       ((A)&((G3_NBANGLE<<G3_FPSHIFT)-1))
  #define G3_ROWSBS(A)      (((A) + 15) >> 4 << 1)
  #define G3_EXTPIXEL(A)    ( (A<<24) | (A<<16) | (A<<8) | (A) )
  #define G3_DIV3(A)        ( ((A<<6)+(A<<4)+(A<<2)+(A)) >> 8 )
  #define G3_DIV4(A)        ( A >> 2 )

  #define G3_EXCHANGESD(A,B)  \
    { \
    SD C;  \
    C=A;      \
    A=B;      \
    B=C;      \
    }

  #define G3_PROJX(X,Z)    ( ((X)/G3_FPSHIFTR(Z,g3_zoomshift))+g3_xmid )
  #define G3_PROJY(Y,Z)    ( g3_ymid - ((Y)/G3_FPSHIFTR(Z,g3_zoomshift)) )

  #define G3_COHEN(V,X,MX)                  \
  {                                         \
    if((UD)(X)>MX)                          \
    {                                       \
      if(X<0) V-=2;                         \
      V++;                                  \
    }                                       \
  }                                         \

  #define G3_OT_ADD(A,B)                         \
    {                                            \
    if(A<0) A=0;                                 \
    if(A>=G3_OTMAX-1) A=G3_OTMAX-2;              \
    if(A>g3_otmax) g3_otmax=A;                   \
    if(A<g3_otmin) g3_otmin=A;                   \
    g3_ptrotitem->next=(G3_OTITEM *)g3_ot[A];    \
    g3_ptrotitem->ptr=B;                         \
    g3_ptrotitem->ptrdvertex=g3_objectdvertex;   \
    g3_ot[A]=g3_ptrotitem;                       \
    g3_ptrotitem++;                              \
    }

  #define G3_OT_ADDEND(B)                        \
    {                                            \
    g3_otmax=G3_OTMAX-1;                         \
    if(G3_OTMAX-1<g3_otmin) g3_otmin=G3_OTMAX-1; \
    g3_ptrotitem->next=(G3_OTITEM *)g3_ot[G3_OTMAX-1];    \
    g3_ptrotitem->ptr=B;                         \
    g3_ptrotitem->ptrdvertex=g3_objectdvertex;   \
    g3_ot[G3_OTMAX-1]=g3_ptrotitem;              \
    g3_ptrotitem++;                              \
    }

  #define G3_PTRDVERTEX_PROJECT(A)                                                              \
      {                                                                                         \
      FP pz;                                                                                    \
      pz=A->z;                                                                                  \
      if(pz>=g3_nearplane)                                                                      \
        {                                                                                       \
        pz=G3_FPSHIFTR(pz,g3_zoomshift);                                                        \
        A->px = g3_xmid+(SD)(A->x/pz);                                                          \
        A->py = g3_ymid-(SD)(A->y/pz);                                                          \
        }                                                                                       \
      }

  #define G3_DVERTEX_PROJECT(A)                                                                 \
      {                                                                                         \
      SD pz;                                                                                    \
      pz=A.z;                                                                                   \
      if(pz>=g3_nearplane)                                                                      \
        {                                                                                       \
        pz=G3_FPSHIFTR(pz,g3_zoomshift);                                                        \
        A.px = g3_xmid+(SD)(A.x/pz);                                                            \
        A.py = g3_ymid-(SD)(A.y/pz);                                                            \
        }                                                                                       \
      }


  #define G3_PTRDVERTEX_LIGHT(A,B)                                                              \
    {                                                                                           \
    G3_VERTEX *ptrvertex;                                                                       \
    G3_MATRIX *ptrmatrix;                                                                       \
    SD  ny;                                                                                     \
    ptrvertex=A->ptrvertex;                                                                     \
    ptrmatrix=&(A->ptrskl->matrix);                                                             \
    ny  =          (ptrmatrix->m12*ptrvertex->nx) +                                             \
                   (ptrmatrix->m22*ptrvertex->ny) +                                             \
                   (ptrmatrix->m32*ptrvertex->nz);                                              \
    ny=G3_FPSHIFTR(ny,(G3_FPSHIFT+G3_FPSHIFT+1-G3_MAXLIGHTINGSHIFT));                           \
    A->light=((G3_MAXLIGHTING>>1)+(SD)(ny)+B) & 0xFF;                                           \
    }

  #define G3_OBJECT_DVERTEXADR(P,O)     ((G3_DVERTEX *)(((UB *)(P))+(O)))

  #define PSEUDONORMALIZE(A,B,C)            \
        {                                   \
        SD m,cptshift;                      \
        m=abs(A);                           \
        if(abs(B)>m) m=abs(B);              \
        if(abs(C)>m) m=abs(C);              \
        cptshift=0;                         \
        while(m>(1<<G3_FPSHIFT))            \
          {                                 \
          m>>=1;                            \
          cptshift++;                       \
          }                                 \
        A>>=cptshift;                       \
        B>>=cptshift;                       \
        C>>=cptshift;                       \
        }


  #define G3_FPXYZ_ROTATETRANSLATE(X,Y,Z,MAT,RX,RY,RZ)\
  {\
    RX=((((X)*MAT.m11)+((Y)*MAT.m21)+((Z)*MAT.m31))>>G3_FPSHIFT)+MAT.m41;\
    RY=((((X)*MAT.m12)+((Y)*MAT.m22)+((Z)*MAT.m32))>>G3_FPSHIFT)+MAT.m42;\
    RZ=((((X)*MAT.m13)+((Y)*MAT.m23)+((Z)*MAT.m33))>>G3_FPSHIFT)+MAT.m43;\
  }\

  #define G3_FPXYZ_ROTATE(X,Y,Z,MAT,RX,RY,RZ)\
  {\
    RX=((((X)*MAT.m11)+((Y)*MAT.m21)+((Z)*MAT.m31))>>G3_FPSHIFT);\
    RY=((((X)*MAT.m12)+((Y)*MAT.m22)+((Z)*MAT.m32))>>G3_FPSHIFT);\
    RZ=((((X)*MAT.m13)+((Y)*MAT.m23)+((Z)*MAT.m33))>>G3_FPSHIFT);\
  }\

  #define G3_COLORALIAS(A,B)    g3_coloralias[((B)*G3_MAXCOLOR+(A))]
  #define G3_COLORLIGHT(A,B)    g3_colorlight[((B)*G3_MAXCOLOR+(A))]
  #define G3_SYMCOLORLIGHT(T,A,B) T[((B)*G3_MAXCOLOR+(A))]

//defines for STM management

#define G3_STM_RUN            0
#define G3_STM_COLLID         1
#define G3_STM_COLLIDEDBY     2
#define G3_STM_CREATE         3
#define G3_STM_DESTROY        4
#define G3_STM_DISPLAY        5
#define G3_STM_INZONE         6


#define G3_OBJECTFLAG_VALID   1
#define G3_OBJECTFLAG_CANRUN  2
#define G3_OBJECTFLAG_VISIBLE 4



#endif


