//**********************************************************************
//          OBJECT GRID LINK SYSTEM  
//**********************************************************************
// Author               : C.Levastre
// Date                 : 1996
//**********************************************************************

#ifndef _G3OBJGRD_H_
#define _G3OBJGRD_H_


#define G3_OBJECTGRIDSIZESHIFT   (6)
#define G3_OBJECTGRIDSIZE        (1<<G3_OBJECTGRIDSIZESHIFT)
#define G3_OBJECTGRIDCONVERT(A)  (((A)>>(G3_FPSHIFT+G3_LANDGRIDSTEPSHIFT+(8-G3_OBJECTGRIDSIZESHIFT)))&(G3_OBJECTGRIDSIZE-1))
#define G3_OBJECTGRIDMAXITEM     G3_MAXOBJECT


typedef struct _g3_objectgriditem
{
  struct    _g3_objectgriditem *ptrnextgriditem;    //pointer on next grid item
  void      *ptrdata;                               //pointer on data
}
G3_OBJECTGRIDITEM;

typedef struct
{
  int x,y;                              //current coords
  G3_OBJECTGRIDITEM *ptrgriditem;       //pointer on current grid item
  int x1,y1;                            //start coords
  int x2,y2;                            //end coords
}
G3_OBJECTGRIDFINDER;

//**********************************************************************
// PROTOTYPES
//**********************************************************************

//grid management
void g3_objectgrid_begin(void);
void g3_objectgrid_end(void);
void g3_objectgrid_put(void *data,int x,int y);
void g3_objectgrid_remove(void *data,int x,int y);
void g3_objectgrid_move(void *ptrdata,int x1,int y1,int x2,int y2);
int g3_objectgrid_itemcount(void);

//grid finder management
G3_OBJECTGRIDITEM *g3_objectgrid_findfirst(G3_OBJECTGRIDFINDER *finder,int x1,int y1,int x2,int y2);
G3_OBJECTGRIDITEM *g3_objectgrid_findnext(G3_OBJECTGRIDFINDER *finder);

#endif

