
#include "g3def.h"
#include "g3malloc.h"
#include "g3error.h"
#include "g3file.h"
#include "g3env.h"
#include "g3vtx.h"
#include "g3skl.h"
#include "g3shape.h"

  SD                 g3_shapecount;
  G3_SHAPE           g3_shape[G3_MAXSHAPE];


/**************************************************************************/
/* shape management                                                       */
/**************************************************************************/

void g3_shape_restore(void)
{
  SD i;
  for(i=0;i<g3_shapecount;i++)
  {
    g3_free(g3_shape[i].ptrvertex);
    g3_free(g3_shape[i].ptrskl);
    g3_free(g3_shape[i].ptrpoly);
  }
  g3_shapecount=0;
}

void g3_shape_init(void)
{
  static callcount=0;
  if(callcount==0)
  {
    g3_shapecount=0;
    callcount++;
  }
  g3_shape_restore();
}

SD g3_shape_count(void)
  {
  return(g3_shapecount);
  }

G3_SHAPE *g3_shape_search(char *name)
  {
    SD i;
    i=0;
    while(i<g3_shapecount && strcmp(g3_shape[i].name,name)) i++;
    if(i<g3_shapecount) return(&g3_shape[i]);
    return(NULL);
  }

G3_SHAPE *g3_shape_load(char *name)
  {
  G3_SHAPE *ptrshape;
  ptrshape=g3_shape_search(name);
  if(!ptrshape)
  {
    // add a new shape in the base
    ptrshape=&g3_shape[g3_shapecount];
    ptrshape->ptrpoly=g3_env_load(name);
    ptrshape->ptrvertex=g3_vtx_load(name);
    ptrshape->ptrskl=g3_skl_load(name);
    strcpy(ptrshape->name,name);
    g3_shapecount++;
  }
  return(ptrshape);
  }

