
#include "g3def.h"
#include "g3file.h"
#include "g3error.h"
#include "g3malloc.h"
#include "g3skl.h"

/**************************************************************************/
/*              MANAGEMENT OF .SKL                                        */
/**************************************************************************/

SD g3_skl_count(G3_SKL *ptrskl)
  {
  SD cpt;
  cpt=0;
  while(ptrskl->recurse!=G3_ENDMARK)
    {
    cpt++;
    ptrskl++;
    }
  return(cpt);
  }

G3_SKL *g3_skl_load(char *name)
  {
  SD version;
  G3_FILE *handle;
  SD sklcount,i;
  G3_SKL *ptrskl,*cptrskl;
  char filename[_MAX_PATH];
  /*----- count number of vertex in this object -----*/
  g3_fextput(name,".SKL",filename);
  handle=g3_fopen(filename,"rb");
  ptrskl=NULL;
  if(handle!=NULL)
    {
    g3_fread(&version,sizeof(version),1,handle);
    g3_fread(&sklcount,sizeof(sklcount),1,handle);
    cptrskl=ptrskl=(G3_SKL *)(g3_malloc(sklcount*sizeof(G3_SKL)+sizeof(SD)));
    if(ptrskl!=NULL)
      {
      switch(version)
        {
        case 1:
          for(i=0;i<sklcount;i++)
            {
            g3_fread(&cptrskl->recurse,sizeof(cptrskl->recurse),1,handle);
            g3_fread(&cptrskl->translation,sizeof(cptrskl->translation),1,handle);
            g3_fread(&cptrskl->rotation,sizeof(cptrskl->rotation),1,handle);
            g3_fread(&cptrskl->target,sizeof(cptrskl->target),1,handle);
            cptrskl++;
            }
          g3_fread(&cptrskl->recurse,sizeof(cptrskl->recurse),1,handle);
          break;
        default:
          g3_error("g3_skl_load : bad version");
        }
      }
    else
      {
      g3_error("g3_skl_load : Error with allocation");
      }
    g3_fclose(handle);
    }
  else
    {
    g3_error("g3_skl_load : Error while openning wb");
    }
  return(ptrskl);
  }

SD g3_skl_save(G3_SKL *ptrskl,char *name)
  {
  SD version;
  G3_FILE *handle;
  SD sklcount,i;
  char filename[_MAX_PATH];
  /*----- count number of vertex in this object -----*/
  sklcount=g3_skl_count(ptrskl);
  if(sklcount>0)
    {
    g3_fextput(name,".SKL",filename);
    handle=g3_fopen(filename,"wb");
    if(handle!=NULL)
      {
      version=1;
      g3_fwrite(&version,sizeof(version),1,handle);
      g3_fwrite(&sklcount,sizeof(sklcount),1,handle);
      for(i=0;i<sklcount;i++)
        {
        g3_fwrite(&ptrskl->recurse,sizeof(ptrskl->recurse),1,handle);
        g3_fwrite(&ptrskl->translation,sizeof(ptrskl->translation),1,handle);
        g3_fwrite(&ptrskl->rotation,sizeof(ptrskl->rotation),1,handle);
        g3_fwrite(&ptrskl->target,sizeof(ptrskl->target),1,handle);
        ptrskl++;
        }
      g3_fwrite(&ptrskl->recurse,sizeof(ptrskl->recurse),1,handle);
      g3_fclose(handle);
      return(G3_TRUE);
      }
    else
      {
      g3_error("g3_skl_save : Error while openning wb");
      }
    }
  else
    {
    g3_error("g3_skl_save : bad skl count");
    }
  return(G3_FALSE);
  }


