
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glide.h>

#include "g3def.h"


#define TDFX_MAXBANK  16

GrHwConfiguration   tdfxv_hwconfig;
int                 tdfxv_enabled=G3_FALSE;
Gu3dfInfo           tdfxv_bankinfo[TDFX_MAXBANK];
GrMipMapId_t        tdfxv_bankmipmap[TDFX_MAXBANK];

void tdfx_release(void)
{
//  grGlideShutdown();
  tdfxv_enabled=G3_FALSE;
}

void tdfx_cls(void)
{
  grBufferClear(0xffffffff,0,GR_WDEPTHVALUE_FARTHEST);
}

int tdfx_loadbank(char *filename,int numbank)
{
  if(gu3dfGetInfo(filename,&tdfxv_bankinfo[numbank]))
  {
    tdfxv_bankinfo[numbank].data=malloc(tdfxv_bankinfo[numbank].mem_required);
    if(tdfxv_bankinfo[numbank].data==0)
  {
    tdfx_release();
    return(G3_FALSE);
    }
    if(!gu3dfLoad(filename,&tdfxv_bankinfo[numbank]))
  {
    tdfx_release();
    return(G3_FALSE);
    }
    tdfxv_bankmipmap[numbank]=guTexAllocateMemory(0,GR_MIPMAPLEVELMASK_BOTH,
                                   tdfxv_bankinfo[numbank].header.width,  
                                   tdfxv_bankinfo[numbank].header.height, 
                                   tdfxv_bankinfo[numbank].header.format,
                                   GR_MIPMAP_NEAREST,
                                   tdfxv_bankinfo[numbank].header.small_lod,
                                   tdfxv_bankinfo[numbank].header.large_lod, 
                                   tdfxv_bankinfo[numbank].header.aspect_ratio,
                                   GR_TEXTURECLAMP_WRAP,
                                   GR_TEXTURECLAMP_WRAP, 
                                   GR_TEXTUREFILTER_BILINEAR,
                                   GR_TEXTUREFILTER_BILINEAR, 
                                   0.0F,
                                   FXFALSE);

    if(tdfxv_bankmipmap[numbank]==GR_NULL_MIPMAP_HANDLE)
  {
     tdfx_release();
       return(G3_FALSE);
    }
    guTexDownloadMipMap(tdfxv_bankmipmap[numbank],tdfxv_bankinfo[numbank].data,&tdfxv_bankinfo[numbank].table.nccTable);
    free(tdfxv_bankinfo[numbank].data);
  return(G3_TRUE);
  }
  else
  {
    tdfx_release();
  return(G3_FALSE);
  }
}

int tdfx_enabled(void)
{
  return(tdfxv_enabled);
}

void tdfx_vga_begin(void)
{
  grSstPassthruMode(GR_PASSTHRU_SHOW_VGA);
}


void tdfx_vga_end(void)
{
  grSstPassthruMode(GR_PASSTHRU_SHOW_SST1);
}



int tdfx_init(void)
{
  //Init glide system
//  grGlideInit();
  //Query hardware
  if(!grSstQueryHardware(&tdfxv_hwconfig))
  {
//    tdfx_release();
    return(G3_FALSE);
  }
  else
    grGlideInit();

  //Select SST 0 
  grSstSelect( 0 );
  //Open up the hardware
  if(!grSstOpen(GR_RESOLUTION_640x480,
                  GR_REFRESH_60Hz,
                  GR_COLORFORMAT_ABGR,
                  GR_ORIGIN_UPPER_LEFT,
                  GR_SMOOTHING_ENABLE,
                  2))
  {
    tdfx_release();
    return(G3_FALSE);
  }
  grRenderBuffer(GR_BUFFER_BACKBUFFER);
  grTexCombineFunction(GR_TMU0, GR_TEXTURECOMBINE_DECAL);
  tdfxv_enabled=G3_TRUE;
  return(G3_TRUE);
}


void tdfx_swapbuffer(void)
{
    int status;
    do
  {
    status = grSstStatus();
    }
  while ((0xffff-((status>>12)&0xffff))>(0x4000));
    grBufferSwap(1);
}


void tdfx_triangle()
{
}


