

#include "g3def.h"
#include "g3file.h"
#include "g3error.h"
#include "g3malloc.h"
#include "g3vtx.h"

/**************************************************************************/
/*              MANAGEMENT OF .VTX                                        */
/**************************************************************************/

SD g3_vtx_count(G3_VERTEX *ptrvertex)
  {
  SD count;
  count=0;
  do
    {
    count++;
    ptrvertex++;
    }
  while(ptrvertex->flag!=G3_ENDMARK);
  return(count);
  }

G3_VERTEX *g3_vtx_load(char *name)
  {
  SD version;
  G3_FILE *handle;
  SD vertexcount,i;
  char filename[_MAX_PATH];
  G3_VERTEX *ptrvertex,*cptrvertex;
  /*----- count number of vertex in this object -----*/
  ptrvertex=NULL;
  g3_fextput(name,".VTX",filename);
  handle=g3_fopen(filename,"rb");
  if(handle!=NULL)
    {
    g3_fread(&version,sizeof(version),1,handle);
    g3_fread(&vertexcount,sizeof(vertexcount),1,handle);
    cptrvertex=ptrvertex=(G3_VERTEX *)(g3_malloc(vertexcount*sizeof(G3_VERTEX)+sizeof(SD)));
      for(i=0;i<vertexcount;i++)
        {
        switch(version)
          {
          case 1:
            g3_fread(&cptrvertex->flag,sizeof(cptrvertex->flag),1,handle);
            G3_FPREAD(cptrvertex->x   ,handle);
            G3_FPREAD(cptrvertex->y   ,handle);
            G3_FPREAD(cptrvertex->z   ,handle);
            G3_FPREAD(cptrvertex->nx  ,handle);
            G3_FPREAD(cptrvertex->ny  ,handle);
            G3_FPREAD(cptrvertex->nz  ,handle);
            cptrvertex->xy=G3_FPMULS(cptrvertex->x,cptrvertex->y);
            break;
        default:
            g3_error("g3_vtx_load : bad version");
          }
        cptrvertex++;
        }
      g3_fread(&cptrvertex->flag,sizeof(cptrvertex->flag),1,handle);
    g3_fclose(handle);
    }
  else
    {
    g3_error("g3_vtx_load : Error while openning file");
    }
  return(ptrvertex);
  }

SD g3_vtx_save(G3_VERTEX *ptrvertex,char *name)
  {
  SD version;
  G3_FILE *handle;
  SD vertexcount,i;
  char filename[_MAX_PATH];
  /*----- count number of vertex in this object -----*/
  vertexcount=g3_vtx_count(ptrvertex);
  if(vertexcount>0)
    {
    g3_fextput(name,".VTX",filename);
    handle=g3_fopen(filename,"wb");
    if(handle!=NULL)
      {
      version=1;
      g3_fwrite(&version,sizeof(version),1,handle);
      g3_fwrite(&vertexcount,sizeof(vertexcount),1,handle);
      for(i=0;i<vertexcount;i++)
        {
        g3_fwrite(&ptrvertex->flag,sizeof(ptrvertex->flag),1,handle);
        G3_FPWRITE(ptrvertex->x   ,handle);
        G3_FPWRITE(ptrvertex->y   ,handle);
        G3_FPWRITE(ptrvertex->z   ,handle);
        G3_FPWRITE(ptrvertex->nx  ,handle);
        G3_FPWRITE(ptrvertex->ny  ,handle);
        G3_FPWRITE(ptrvertex->nz  ,handle);
        ptrvertex++;
        }
      g3_fwrite(&ptrvertex->flag,sizeof(ptrvertex->flag),1,handle);
      g3_fclose(handle);
      return(G3_TRUE);
      }
    else
      {
      g3_error("g3_vtx_save : Error while openning file");
      }
    }
  else
    {
    g3_error("Bad Vertex count");
    }
  return(G3_FALSE);
  }

